<?php


namespace Repository;

use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Traits\TQuery;

class AclLabels extends RepositoryBase
{

    use TQuery;

    const ENTITY_NAME = '\Zeedhi\DevOps\Model\Profile\Entities\AclLabels';
    /**
     * @var EntityManager
     */
    private $entityManager;

    public function __construct()
    {
        parent::__construct(self::ENTITY_NAME);
        $this->entityManager = InstanceProvider::getEntityManager();
    }

    /**
     * @param $projectId
     * @return array
     */
    public function findAclLabelsByProject($projectId): array
    {
        $query = <<<SQL
            SELECT ALB.ID, ALB.PROJECT_ID, ALB.LABELS_FILE
                  FROM ACL_LABELS ALB
                 WHERE ALB.PROJECT_ID = :PROJECT_ID
SQL;
        $params = array(
            ':PROJECT_ID' => $projectId
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }

}
