<?php

/**
 * User: rafaelporto
 *
 * Messy service for 'Solicitação' building
 * This is based on old code written in ASP/Delphi/Old Things And Structures For Applications
 * (transliteration of old code was required)
 */

namespace Service\Integration;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Geral\Entities\Operador;
use Util\InstanceProvider;
use Zeedhi\DevOps\Util\Utilities;

class INTRANETIntegration {

    const CREATED_BY_GEP = 'CREATED_BY_GEP';

    /** @var EntityManager $entityManager */
    protected $entityManager;
    /** @var  \Service\Teknisa\NewCode $newCodeService */
    protected $newCodeService;
    /** @var \Factory\Contato $contatoFactory */
    protected $contatoFactory;
    /** @var \Factory\LogFaseTram $logFaseTramFactory */
    public $logFaseTramFactory;

    /** @var \Teknisa\Model\Geral\Repositories\Operador $operadorRepository */
    protected $operadorRepository;
    /** @var \Teknisa\Model\Geral\Repositories\Paramgeral $paramGeralRepository */
    protected $paramGeralRepository;
    /** @var \Teknisa\Model\Geral\Repositories\Cliente $clientRepository */
    protected $clienteRepository;
    /** @var \Teknisa\Model\Geral\Repositories\Produto $produtoRepository */
    protected $produtoRepository;
    /** @var \Teknisa\Model\Teknisa\Repositories\Assusoli $assuSoliRepository */
    protected $assuSoliRepository;
    /** @var \Teknisa\Model\Teknisa\Repositories\CpCallComment $callCommentRepository */
    protected $callCommentRepository;
    /** @var \Teknisa\Model\Crm\Repositories\Pararelatione $pararelationeRepository */
    protected $pararelationeRepository;
    /** @var \Teknisa\Model\Geral\Repositories\Parcnegocio $parcnegocioRepository */
    protected $parcnegocioRepository;
    /** @var \Teknisa\Model\Teknisa\Repositories\CpCallAttachment $callAttachmentRepository */
    protected $callAttachmentRepository;
    /** @var \Teknisa\Model\Teknisa\Repositories\Soliserv $soliservRepository */
    protected $soliservRepository;
    public $basicIntranetFileDir;

    public function __construct(EntityManager $entityManager) {

        $this->entityManager = $entityManager;
        $this->newCodeService = InstanceProvider::getService()->getTeknisaNewCode();
        $this->contatoFactory = InstanceProvider::getFactory()->getContato();;
        $this->logFaseTramFactory = InstanceProvider::getFactory()->getLogFaseTram();
        $this->basicIntranetFileDir = InstanceProvider::getBasicIntranetFileDir();

        $this->operadorRepository       = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Operador');
        $this->paramGeralRepository     = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Paramgeral');
        $this->clienteRepository        = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Cliente');
        $this->produtoRepository        = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Produto');
        $this->assuSoliRepository       = $this->entityManager->getRepository('\Teknisa\Model\Teknisa\Entities\Assusoli');
        $this->callCommentRepository    = $this->entityManager->getRepository('\Teknisa\Model\Teknisa\Entities\CpCallComment');
        $this->pararelationeRepository  = $this->entityManager->getRepository('\Teknisa\Model\Crm\Entities\Pararelatione');
        $this->parcnegocioRepository    = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Parcnegocio');
        $this->logfaseTramRepository    = $this->entityManager->getRepository('\Teknisa\Model\Teknisa\Entities\Logfasetram');
        $this->callAttachmentRepository = $this->entityManager->getRepository('\Teknisa\Model\Teknisa\Entities\CpCallAttachment');
        $this->soliservRepository       = $this->entityManager->getRepository('\Teknisa\Model\Teknisa\Entities\Soliserv');
    }

    private function gravaContIncluirSolic($P_CDCLIENTE, $P_CDOPERADOR, $P_NRSOLISERV, $P_DSREFERENCIA,
                                           $P_CDASSUNTO, $P_CDGRUPO, $P_NMSISTEMA, $P_CDVERSAO, $P_NRCONTATO)
    {
        $connection = $this->entityManager->getConnection();
        try {
            $acmEvolCont = "
                INSERT INTO EVOLCONT
                (CDFILIAL, NRCONTATO, DTHREVOLCONT, CDTIPOCONT, CDCLIENTE, NMINTEVOCONT,
                IDSENEVOCONT, IDTPEVOLCONT, DSEVOLCONT, CDOPEREVOL)
                VALUES
                (:CDFILIAL, :NRCONTATO, :DTHREVOLCONT, :CDTIPOCONT, :CDCLIENTE, :NMINTEVOCONT,
                 :IDSENEVOCONT, :IDTPEVOLCONT, :DSEVOLCONT, :CDOPEREVOL)
            ";

            $acmEvolContParams = array(
                'CDFILIAL'      => '',
                'NRCONTATO'     => $P_NRCONTATO,
                'DTHREVOLCONT'  => '',
                'CDTIPOCONT'    => '',
                'CDCLIENTE'     => $P_CDCLIENTE,
                'NMINTEVOCONT'  => '',
                'IDSENEVOCONT'  => 'E',
                'IDTPEVOLCONT'  => 'C',
                'DSEVOLCONT'    => '',
                'CDOPEREVOL'    => ''
            );

            $paramGeral = $this->paramGeralRepository->findOneBy(array());
            $operador = $this->operadorRepository->findOneBy(array('cdoperador' => $P_CDOPERADOR));
            $assuSoli = $this->assuSoliRepository->findOneBy(array('cdassusoli' => $P_CDASSUNTO));
            $grupSist = $this->produtoRepository->findOneBy(array('cdproduto' => $P_CDGRUPO));

            $now = \Util\DateUtil::getDataAtual(true)->format(\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $now = explode(" ", $now)[0];
            $now = \DateTime::createFromFormat(\Util\DateUtil::FORMATO_BRASILEIRO, $now);
            $acmEvolContParams['CDFILIAL'    ] = $paramGeral->getCdfilial();
            $acmEvolContParams['DTHREVOLCONT'] = $now->format(\Util\DateUtil::FORMATO_BRASILEIRO);
            $acmEvolContParams['CDTIPOCONT'  ] = $paramGeral->getCdtipcontweb();
            $acmEvolContParams['NMINTEVOCONT'] = $operador->getNmoperador();
            $acmEvolContParams['CDOPEREVOL'  ] = $P_CDOPERADOR;

            $nmAssuSoli = empty($assuSoli) ? "" : $assuSoli->getNmassusoli();
            $nmProduto = $grupSist->getNmproduto();
            if ($P_CDVERSAO == '') {
                $acmEvolContParams['DSEVOLCONT'] =
                    "Foi incluída a solicitação " . $P_NRSOLISERV . " referente a " . $P_DSREFERENCIA .
                    " classificada como " . $nmAssuSoli . " para o grupo " . $nmProduto .
                    " e sistema " . $P_NMSISTEMA . ".";

            } else if ($P_CDVERSAO != '') {
                $acmEvolContParams['DSEVOLCONT'] =
                    "Foi incluída a solicitação " . $P_NRSOLISERV . " referente a " . $P_DSREFERENCIA .
                    " classificada como " . $nmAssuSoli . " para o grupo " . $nmProduto .
                    ", sistema " . $P_NMSISTEMA . " e versão " . $P_CDVERSAO . ".";
            }

            $connection->beginTransaction();

            $connection->executeQuery($acmEvolCont, $acmEvolContParams);

            $this->entityManager->flush();
            $connection->commit();
        } catch(\Exception $e) {
            $connection->rollBack();
            throw $e;
        }
    }

    // TODO: Refactor on this duplicities with Contato's creation on SupportCall service

    //Verifica se há um modelo de caso inserido na tabela PARARELATIONE
    private function retornaModeloCasoPararelatione() {
        return $this->pararelationeRepository->getNrseqmodelocaso();
    }

    //Retorna dados da tabela CRM_MODELOCASO
    private function retornaDadosModeloCaso($nrorg){
        $nrseqmodelocaso = $this->retornaModeloCasoPararelatione();
        if (!empty($nrseqmodelocaso))
        {
            $sql = "SELECT CDMNEMONICOCASO,     NRSITUACAOABERTURA,     IDGERAFATURCASO,
                           IDGERAEVOLUCAO,      NRTPCONTATOEVOLPADR,    CDMOTIVOEVOLPADR,
                           DSEVOLUCAOPADR,      IDGERAFATUREVOL
                      FROM CRM_MODELOCASO
                     WHERE NRSEQMODELOCASO = ".$nrseqmodelocaso."
                       AND NRORG = ".$nrorg;
            $retorno = $this->entityManager->getConnection()->fetchAll($sql);
            return $retorno[0];
        } else {
            return null;
        }

    }

    //Gera o código do caso de acordo com os mnemonicos definidos na tela Modelo de Caso.
    private function geraCodigoCaso($nrorg, $dthrcontato) {
        $modelo = $this->retornaDadosModeloCaso($nrorg);
        $contatocd = $this->newCodeService->getCodeByTableName('CONTATOCD', $nrorg, 1, 10, true );

        if (!empty($modelo))
        {
            $cdmnemonicocaso = $modelo['CDMNEMONICOCASO'];
            $data = $dthrcontato;
            $data = \Util\DateUtil::getDataDeString($data,\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $mes = \Util\DateUtil::getMes($data);
            $ano = \Util\DateUtil::getAno($data);

            if (!empty($cdmnemonicocaso))
            {
                $cdcaso = str_replace('[SEQ]',$contatocd, $cdmnemonicocaso);
                $cdcaso = str_replace('[MES]',$mes,$cdcaso);
                $cdcaso = str_replace('[ANO]',$ano,$cdcaso);
            }
            else
            {
                $cdcaso = $contatocd."_".$mes."/".$ano;
            }
        }
        else
        {
            $data = \Util\DateUtil::getDataAtual();
            $mes = \Util\DateUtil::getMes($data);
            $ano = \Util\DateUtil::getAno($data);
            $cdcaso = $contatocd."_".$mes."/".$ano;
        }
        return $cdcaso;
    }

    private function getTipoContato($nrParcNegocio, $nrOrg){

        $parceiro = $this->parcnegocioRepository->findOneBy(array(
            'nrparcnegocio' => $nrParcNegocio,
            'nrorg' => $nrOrg
        ));

        $idTpContato = $parceiro->getCdtipoparcprincipal();

        switch ($idTpContato) {
            case 'CLIENTE':
                $tpcontato = 'C';
                break;
            case 'FORNECEDOR':
                $tpcontato = 'F';
                break;
            default:
                $tpcontato = 'P';
        }

        return $tpcontato;
    }

    private function getNrParcNegocioByCdOperador($cdOperador) {
        $sql = "SELECT NRPARCNEGOCIO
                FROM (
                      SELECT REL.NRPARCNEGOCIO, PARC.NMPRINCIPALPARC
                      FROM RELACIONAPARC REL
                      INNER JOIN OPERADOR OPER ON REL.NRPARCNEGRELAC = OPER.NRPARCNEGOCIO
                                               AND REL.NRORG = OPER.NRORG
                      INNER JOIN PARCNEGOCIO PARC ON REL.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                                                  AND REL.NRORG = PARC.NRORG
                      WHERE REL.NRTIPORELACIONA = 25 AND PARC.IDATIVO = 'S'
                            AND REL.IDATIVO = 'S' AND OPER.CDOPERADOR = :CDOPERADOR
                ) PARCNEGOCIO";

        $params = array(
            'CDOPERADOR' => $cdOperador
        );

        $return = $this->entityManager->getConnection()->fetchAll($sql, $params);
        return !empty($return) ? $return[0]['NRPARCNEGOCIO'] : null;
    }

    private function createContatoDeConsulta($cdOperador,$cdCliente) {
        $connection = $this->entityManager->getConnection();
        try {
            /** @var \Teknisa\Model\Geral\Entities\Operador $operador */
            $operador = $this->operadorRepository->findOneBy(array('cdoperador' => $cdOperador));
            $nrOrg = $operador->getNrorg();

            $dsRefeCont = $operador->getNmoperador() . ' consultou S@C através do CP';

            $dtHrContato = \Util\DateUtil::getDataAtual(true)->format(\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $cdCaso = $this->geraCodigoCaso($nrOrg, $dtHrContato);
            $dtHrContato = explode(" ", $dtHrContato)[0];
            $dtHrContato = \DateTime::createFromFormat(\Util\DateUtil::FORMATO_BRASILEIRO, $dtHrContato);

            $cdFilial = $this->paramGeralRepository->findOneBy(array())->getCdfilial();
            $cdMotiCont = 91;
            $cdOperInclusao = $operador->getCdoperador();

            $nrContato = $this->newCodeService->getCodeByTableName('CONTATO'.$cdFilial, $nrOrg);

            $nrseqcontato = $this->newCodeService->getCodeByTableName('NRSEQCONTATO', $nrOrg);
            $idTpContato = $this->getTipoContato($operador->getNrparcnegocio(), $nrOrg);
            $nrParcNegocio = $this->getNrParcNegocioByCdOperador($cdOperInclusao);

            $contatoDeConsulta = $this->contatoFactory->createContato($cdCaso, $nrOrg, $dsRefeCont, null, $dtHrContato,
                    $nrContato, $cdFilial, $cdCliente, $idTpContato, null, $cdMotiCont, $cdOperInclusao, null,
                    $nrParcNegocio, $nrseqcontato);


            $connection->beginTransaction();

            $this->entityManager->persist($contatoDeConsulta);

            $this->entityManager->flush();
            $connection->commit();
        } catch(\Exception $e) {
            $connection->rollBack();
            throw $e;
        }

        return $nrContato;
    }

    public function createAndPersistSolicitacao($P_CDCLIENTE, $P_CDOPERADOR, $P_DSREFESOLI, $P_CDASSUNTO, $P_CDGRUPSIST,
                                       $P_CDSISTEMA, $P_NRLICENCAUSO, $P_DSSOLISERV, $P_DSVERSAO,
                                       $P_CDRELEASE = '',$P_CDPATCH = '', $P_CDSETOR = '')
    {
        $connection = $this->entityManager->getConnection();
        $P_NRCONTATO = $this->createContatoDeConsulta($P_CDOPERADOR,$P_CDCLIENTE);
        $nrOrg = $this->operadorRepository->findOneBy(array('cdoperador' => $P_CDOPERADOR))->getNrorg();

        $stCdOperResp = '';
        $cdversao = '';
        $cdrelease = $P_CDRELEASE;
        $cdpatch = $P_CDPATCH;

        $adqPesqVersao = "
            SELECT
               PR.CDVERPRODUTO
            FROM
               PRODLIBEVERS PR
            WHERE
              (PR.CDPRODGRUP   = :P_CDPRODGRUP) AND
              (PR.CDPRODCOMP   = :P_CDPRODCOMP) AND
              (PR.CDVERPRODUTO = NVL(:P_CDVERPRODUTO, PR.CDVERPRODUTO))
            ORDER BY PR.CDVERPRODUTO
        ";

        $adqPesqVersaoParams = array(
            'P_CDPRODGRUP' => '',
            'P_CDPRODCOMP' => '',
            'P_CDVERPRODUTO' => ''
        );

        $adqPesqRelease = "
            SELECT
               CDRELVERPROD, DTRELVERPROD
            FROM
               RELEVERPROD
            WHERE
            (CDPRODGRUP   = :P_CDGRUPSIST) AND
               (CDVERPRODUTO = :P_CDVERSGSIS) AND
               (CDRELVERPROD = :P_CDRELEASE OR 'T' = :P_TCDRELEASE)
            ORDER BY CDRELVERPROD DESC
        ";

        $adqPesqReleaseParams = array(
            'P_CDGRUPSIST' => '',
            'P_CDVERSGSIS' => '',
            'P_CDRELEASE' => '',
            'P_TCDRELEASE' => ''
        );

        $adqPesqPatch = "
            SELECT
                CDPATCHVERPR
            FROM
                PATCHVERPROD
            WHERE
                CDPRODGRUP   = :P_CDGRUPSIST   AND
                CDVERPRODUTO = :P_CDVERSGSIS   AND
                CDRELVERPROD = :P_CDRELEASEVER AND
                CDPATCHVERPR = NVL(:P_CDPATCHVERPR, CDPATCHVERPR)
            ORDER BY CDPATCHVERPR DESC
        ";

        $adqPesqPatchParams = array(
            'P_CDGRUPSIST' => '',
            'P_CDVERSGSIS' => '',
            'P_CDRELEASEVER' => '',
            'P_CDPATCHVERPR' => ''
        );

        $adqParamGeral = "
            SELECT
                PAR.CDFATRAMIWEB,
                PAR.CDFATRAMENCE,
                FA.IDDEPACAOOPE,
                FA.CDGROPERRESP,
                PAR.CDCOMPLEXINI
            FROM
                FASETRAM FA,
                GRUPOPER GR,
                PARAMGERAL PAR
            WHERE
                (FA.CDGROPERRESP  = GR.CDGRUPOPER (+)) AND
                (PAR.CDFATRAMIWEB = FA.CDFASETRAM)
        ";

        $adqParamGeralParams = array();

        $adqFilial = "
            SELECT CDFILIAL
            FROM PARAMGERAL
        ";

        $adqFilialParams = array();

        $adqGrupOper = "
            SELECT
                OP.CDOPERADOR,
                OP.NMOPERADOR
            FROM
                OPERGRUPOP OG,
                OPERADOR OP
            WHERE
                OG.CDOPERADOR = OP.CDOPERADOR AND
                OG.CDGRUPOPER = :P_CDGRUPOPER AND
                OP.IDOPERATIVO = 'A'
            ORDER BY OP.NMOPERADOR
        ";

        $adqGrupOperParams = array(
            'P_CDGRUPOPER' => ''
        );

        $adqOperResp = "
            SELECT CDOPERADOR, NRORG
            FROM OPERCLIE
            WHERE
                (CDCLIENTE    = :P_CDCLIENTE) AND
                (IDTPOPERCLIE = :P_IDTPOPERCLIE)
            ORDER BY NRPRIOPERCLI
        ";

        $adqOperRespParams = array(
            'P_CDCLIENTE' => '',
            'P_IDTPOPERCLIE' => ''
        );

        $acmInsSoliServ = "
            INSERT INTO SOLISERV
                (CDCLIENTE,DSREFESOLI,CDASSUNTO,CDPRODCOMP,CDPRODGRUP,
                DSPATCHORIG,CDFILIAL,CDFASETRAM,NRSOLISERV,CDOPERADOR,
                NRPRIOSOLI,IDSTATUSSOLI,IDSOLIENCE,CDOPERRESP,CDOPERSOLI,
                IDSOLILIDA,NRLICENCAUSO,IDSOLCTRLSLA,CDCOMPLEXID,DTABERSOLI,
                CDVERPROORIG, CDRELVERORIG, CDPATRELORIG, CDSETOR, NRORG)
            VALUES
                (:CDCLIENTE,:DSREFESOLI,:CDASSUNTO,:CDPRODCOMP,:CDPRODGRUP,
                :DSPATCHORIG,:CDFILIAL,:CDFASETRAM,:NRSOLISERV,:CDOPERADOR,
                :NRPRIOSOLI,:IDSTATUSSOLI,:IDSOLIENCE,:CDOPERRESP,:CDOPERSOLI,
                :IDSOLILIDA,:NRLICENCAUSO,:IDSOLCTRLSLA,:CDCOMPLEXID, SYSDATE,
                :CDVERPROORIG, :CDRELVERORIG, :CDPATRELORIG, :CDSETOR, :NRORG)
        ";

        $acmInsSoliServParams = array(
            'CDCLIENTE' => '', 'DSREFESOLI' => '', 'CDASSUNTO' => '', 'CDPRODCOMP' => '', 'CDPRODGRUP' => '',
            'DSPATCHORIG' => '', 'CDFILIAL' => '', 'CDFASETRAM' => '', 'NRSOLISERV' => '',  'CDOPERADOR' => '',
            'NRPRIOSOLI' => '',  'IDSTATUSSOLI' => '', 'IDSOLIENCE' => '', 'CDOPERRESP' => '', 'CDOPERSOLI' => '',
            'IDSOLILIDA' => '', 'NRLICENCAUSO' => '', 'IDSOLCTRLSLA' => '', 'CDCOMPLEXID' => '', 'CDVERPROORIG' => '',
            'CDRELVERORIG' => '', 'CDPATRELORIG' => '', 'CDSETOR' => '', 'NRORG' => ''
        );

        $acmInsDsSoliServ = "
            INSERT INTO DESCSOLI
                (CDFILIAL,
                NRSOLISERV,
                DSSOLISERV)
            VALUES
                (:CDFILIAL,
                :NRSOLISERV,
                RAWTOHEX(:DSSOLISERV))
        ";

        $acmInsDsSoliServParams = array(
            'CDFILIAL' => '', 'NRSOLISERV' => '', 'DSSOLISERV' => ''
        );

        $acmInsLogFaseTram = "
            INSERT INTO LOGFASETRAM
                (CDFILIAL, NRSOLISERV, CDFASETRAM, CDOPERRESP, CDOPERADOR, DSALFASETRAM, DTALFASETRAM, TXACAOLFTRAM)
            VALUES
                (:CDFILIAL, :NRSOLISERV, :CDFASETRAM, :CDOPERRESP,  :CDOPERADOR, :DSALFASETRAM, SYSDATE, :TXACAOLFTRAM)
        ";

        $acmInsLogFaseTramParams = array(
            'CDFILIAL' => '', 'NRSOLISERV' => '', 'CDFASETRAM' => '', 'CDOPERRESP' => '', 'CDOPERADOR' => '',
            'DSALFASETRAM' => '', 'TXACAOLFTRAM' => ''
        );
        $produto = $this->produtoRepository->findOneBy(array('cdproduto' => $P_CDSISTEMA, 'nrorg' => $nrOrg));
        $cdsistema = $produto->getCdproduto();
        $nmsistema = $produto->getNmproduto();

        $adqPesqVersaoParams['P_CDPRODGRUP'] = $P_CDGRUPSIST;
        $adqPesqVersaoParams['P_CDPRODCOMP'] = $cdsistema;
        $adqPesqVersaoParams['P_CDVERPRODUTO'] = str_replace('.', '', $P_DSVERSAO);
        $adqPesqVersaoResults = $connection->fetchAll($adqPesqVersao, $adqPesqVersaoParams);

        if(!empty($adqPesqVersaoResults[0]['CDVERPRODUTO'])) {

            $cdversao = $adqPesqVersaoResults[0]['CDVERPRODUTO'];

            if(!empty($P_CDRELEASE)) {
                $adqPesqReleaseParams['P_CDGRUPSIST'] = $P_CDGRUPSIST;
                $adqPesqReleaseParams['P_CDVERSGSIS'] = $cdversao;
                $adqPesqReleaseParams['P_CDRELEASE'] = $P_CDRELEASE;
                $adqPesqReleaseResults =  $connection->fetchAll($adqPesqRelease, $adqPesqReleaseParams);

                if(!empty($adqPesqReleaseResults[0]['CDRELVERPROD'])) {
                    if(!$cdrelease){
                        $cdrelease = $adqPesqReleaseResults[0]['CDRELVERPROD'];
                    }

                    if(!empty($P_CDPATCH)) {
                        $adqPesqPatchParams['P_CDGRUPSIST'] = $P_CDGRUPSIST;
                        $adqPesqPatchParams['P_CDVERSGSIS'] = $cdversao;
                        $adqPesqPatchParams['P_CDRELEASEVER'] = $cdrelease;
                        $adqPesqPatchParams['P_CDPATCHVERPR'] = $P_CDPATCH;
                        $adqPesqPatchResults = $connection->fetchAll($adqPesqPatch, $adqPesqPatchParams);

                        $cdpatch = empty($adqPesqPatchResults[0]['CDPATCHVERPR']) ? '' : $adqPesqPatchResults[0]['CDPATCHVERPR'];
                    }
                }
            }
        }

        $adqFilialResults = $connection->fetchAll($adqFilial, $adqFilialParams);
        $adqParamGeralResults = $connection->fetchAll($adqParamGeral, $adqParamGeralParams);

        if($adqParamGeralResults[0]['IDDEPACAOOPE'] == 'G') {
            $adqGrupOperParams['P_CDGRUPOPER'] = $adqParamGeralResults[0]['CDGROPERRESP'];
            $adqGrupOperResults = $connection->fetchAll($adqGrupOper, $adqGrupOperParams);

            $stCdOperResp = $adqGrupOperResults[0]['CDOPERADOR'];
        } else if ($adqParamGeralResults[0]['IDDEPACAOOPE'] == 'R' || $adqParamGeralResults[0]['IDDEPACAOOPE'] == 'C') {
            $adqOperRespParams['P_CDCLIENTE'] = $P_CDCLIENTE;
            $adqOperRespParams['P_IDTPOPERCLIE'] = $adqParamGeralResults[0]['IDDEPACAOOPE'];
            $adqOperRespResults = $connection->fetchAll($adqOperResp, $adqOperRespParams);

            $stCdOperResp = $adqOperRespResults[0]['CDOPERADOR'];
        }

        $stAuxLicenca = \Util\Utilities::zeroLeftPadding($P_NRLICENCAUSO, 10);
        $stIdCtrlSla = 'N';
        $stCdComplexid = '';
        $stNrSoliServ = $this->newCodeService->getCodeByTableName('SOLISERV9999', $nrOrg);

        $acmInsSoliServParams['CDCLIENTE'   ] = $P_CDCLIENTE;
        $acmInsSoliServParams['DSREFESOLI'  ] = $P_DSREFESOLI;
        $acmInsSoliServParams['CDASSUNTO'   ] = $P_CDASSUNTO;
        $acmInsSoliServParams['CDPRODCOMP'  ] = $cdsistema;
        $acmInsSoliServParams['CDPRODGRUP'  ] = $P_CDGRUPSIST;
        $acmInsSoliServParams['DSPATCHORIG' ] = $P_DSVERSAO;
        $acmInsSoliServParams['CDFILIAL'    ] = $adqFilialResults[0]['CDFILIAL'];
        $acmInsSoliServParams['CDFASETRAM'  ] = $adqParamGeralResults[0]['CDFATRAMIWEB'];
        $acmInsSoliServParams['NRSOLISERV'  ] = $stNrSoliServ;
        $acmInsSoliServParams['CDOPERADOR'  ] = $P_CDOPERADOR;
        $acmInsSoliServParams['NRPRIOSOLI'  ] = '000';
        $acmInsSoliServParams['IDSTATUSSOLI'] = 'P';
        $acmInsSoliServParams['IDSOLIENCE'  ] = 'N';
        $acmInsSoliServParams['CDOPERRESP'  ] = $stCdOperResp;
        $acmInsSoliServParams['CDOPERSOLI'  ] = $P_CDOPERADOR;
        $acmInsSoliServParams['IDSOLILIDA'  ] = 'N';
        $acmInsSoliServParams['NRLICENCAUSO'] = $stAuxLicenca;
        $acmInsSoliServParams['IDSOLCTRLSLA'] = $stIdCtrlSla;
        $acmInsSoliServParams['CDCOMPLEXID' ] = $stCdComplexid;
        $acmInsSoliServParams['CDVERPROORIG'] = $cdversao;
        $acmInsSoliServParams['CDRELVERORIG'] = $cdrelease;
        $acmInsSoliServParams['CDPATRELORIG'] = $cdpatch;
        $acmInsSoliServParams['CDSETOR'     ] = $P_CDSETOR;
        $acmInsSoliServParams['NRORG'       ] = $nrOrg;

        $acmInsDsSoliServParams['CDFILIAL'  ] = $adqFilialResults[0]['CDFILIAL'];
        $acmInsDsSoliServParams['NRSOLISERV'] = $stNrSoliServ;
        $acmInsDsSoliServParams['DSSOLISERV'] = $P_DSSOLISERV;

        $acmInsLogFaseTramParams['CDFILIAL'    ] = $adqFilialResults[0]['CDFILIAL'];
        $acmInsLogFaseTramParams['NRSOLISERV'  ] = $stNrSoliServ;
        $acmInsLogFaseTramParams['CDFASETRAM'  ] = $adqParamGeralResults[0]['CDFATRAMIWEB'];
        $acmInsLogFaseTramParams['CDOPERRESP'  ] = $stCdOperResp;
        $acmInsLogFaseTramParams['CDOPERADOR'  ] = $P_CDOPERADOR;
        $acmInsLogFaseTramParams['DSALFASETRAM'] = 'Abertura da Solicitação';
        $acmInsLogFaseTramParams['TXACAOLFTRAM'] = 'Abriu a solicitação';

        try {
            $connection->beginTransaction();

            $connection->executeQuery($acmInsSoliServ, $acmInsSoliServParams);
            $connection->executeQuery($acmInsDsSoliServ, $acmInsDsSoliServParams);
            $connection->executeQuery($acmInsLogFaseTram, $acmInsLogFaseTramParams);

            $this->gravaContIncluirSolic($P_CDCLIENTE, $P_CDOPERADOR, $stNrSoliServ, $P_DSREFESOLI,
                $P_CDASSUNTO, $P_CDGRUPSIST, $nmsistema, $P_DSVERSAO, $P_NRCONTATO);

            $this->entityManager->flush();
            $connection->commit();
        } catch(\Exception $e) {
            $connection->rollBack();
            throw $e;
        }

        return $stNrSoliServ;
    }

    public function findCommentsOnSolicitacaoForProductCall($nrSoliServ, Operador $currentUser) {
        $cdClienteBase = \Util\Utilities::getCdClienteBase();
        $isTeknisaFunc = !!$currentUser->getCdfunc() && $currentUser->getCdcliente() == $cdClienteBase ;
        return $this->callCommentRepository->getProductCallCommentsFromSolicitacao($nrSoliServ,$cdClienteBase,$isTeknisaFunc);
    }

    public function saveCommentOnSolicitacaoByProductCallComment($nrSoliServ, $subject, $description, $operador,$nrorgId) {
        $connection = $this->entityManager->getConnection();
        try {
            $connection->beginTransaction();

            /** @var \Teknisa\Model\Geral\Entities\Paramgeral $paramGeral */
            $paramGeral = $this->paramGeralRepository->findOneBy(array());
            /** @var \Teknisa\Model\Geral\Entities\Operador $operador */
            $operador = $this->operadorRepository->findOneBy(array('cdoperador' => $operador,'nrorg' =>$nrorgId));
            /** @var \Teknisa\Model\Teknisa\Entities\Soliserv $soliServ */
            $soliServ = $this->soliservRepository->findOneBy(array('nrsoliserv' => $nrSoliServ));

            $nrOrg = $operador->getNrorg();
            $cdFilial = $paramGeral->getCdfilial();
            $dt = new \DateTime();
            $dtString = $dt->format(\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $cdFaseTram = $soliServ->getCdfasetram();
            $cdOperador = $operador->getCdoperador();
            $cdOperResp = $soliServ->getCdoperresp();
            $txacaolftram = $subject;
            $dsAlFaseTram = $description;

            /* This is necessary because god knows why datetime looses its time property on insertion through doctrine */
            list($logFaseTramInsertionQuery, $logFaseTramInsertionQueryParams) = $this->logFaseTramFactory->createLogFaseTramInsertionQuery(
                $nrOrg, $cdFilial, $nrSoliServ, $dtString, $cdFaseTram, $cdOperador, $cdOperResp, $txacaolftram, $dsAlFaseTram,$cdOperador);

            $connection->executeQuery($logFaseTramInsertionQuery, $logFaseTramInsertionQueryParams);
            $this->entityManager->flush();

            $connection->commit();
            return $dt;
        } catch(\Exception $e) {
            $connection->rollBack();
            throw $e;
        }
    }
    /**
     * @param $documents
     * @param $callRelationship
     * @param $dateString
     * @return mixed
     */
    public function insertFile($documents,$callRelationship, $dateString)
    {
        $basic = $this->basicIntranetFileDir;
        $directory = $basic . DIRECTORY_SEPARATOR . $callRelationship . DIRECTORY_SEPARATOR . $dateString;
        \Service\Attachment::directoryCheck($directory);
        foreach ($documents as &$fileData) {
            \Util\Utilities::factoryFromFileData($fileData, $directory);
            $fileData['path'] = $directory . DIRECTORY_SEPARATOR . $fileData['name'];
        }
        return $documents;
    }

    public function insertFileSpecificationTaskS($documents,$callRelationship)
    {
        $basic = $this->basicIntranetFileDir;
        $directory = $basic . DIRECTORY_SEPARATOR . $callRelationship. DIRECTORY_SEPARATOR . 'REQUISITO' ;
        \Service\Attachment::directoryCheck($directory);
        foreach ($documents as &$fileData) {
            \Util\Utilities::factoryFromFileData($fileData, $directory);
            $fileData['path'] = $directory . DIRECTORY_SEPARATOR . $fileData['name'];
        }
        return $documents;
    }

    public function deleteAttachment(\Teknisa\Model\Teknisa\Entities\CpCallAttachment $callAttachment)
    {
        try{
            unlink($callAttachment->getFilename());
        }catch (\Exception $e){}
    }
    public function deleteCharEspecial($dir)
    {
        $folders = explode(DIRECTORY_SEPARATOR,$dir);
        $fileOrigin = array_pop($folders);
        $folder = implode(DIRECTORY_SEPARATOR,$folders);
        if(file_exists($folder)){
            $files = scandir($folder);
            foreach ($files as $file) {
                if(mb_detect_encoding($file) == "UTF-8"){
                    $fileUTF8 = mb_convert_encoding($file, 'UTF-8', 'ISO-8859-1');
                    if($fileOrigin == $fileUTF8) {
                        unlink($folder.DIRECTORY_SEPARATOR.$file);
                    }
                }

            }
        }
    }
    public function deleteFile($dir)
    {
        try{
            unlink($dir);
        }catch (\Exception $e){
            $this->deleteCharEspecial($dir);
        }
    }

    public function validateFileSpecification($file){
        $validation = true;
        if(!\Util\Utilities::endsWithString($file,[".doc"])){
            $validation = false;
        }
        return $validation;
    }


    public function getPageRequisite($nrsoliserv){
        $callDir = $this->basicIntranetFileDir.DIRECTORY_SEPARATOR.$nrsoliserv.DIRECTORY_SEPARATOR.'REQUISITO'.DIRECTORY_SEPARATOR;

        $fileName = [
            "name" => null,
            "created" => 0
        ];
        $notFile = array('.','..');
        $files = scandir($callDir);
        foreach ($files as $file) {
            if(mb_detect_encoding($file) == "UTF-8"){
                $file = mb_convert_encoding($file, 'UTF-8', 'ISO-8859-1');
            }
            if(!in_array($file,$notFile) && filemtime($callDir.$file) > $fileName["created"]){
                $fileName["name"] = $file;
                $fileName["fileName"] = $callDir.$file;
                $fileName["created"] = filemtime($callDir.$file);
            }
        }


        if($fileName["name"]){
            $fileName["extension"] = mime_content_type($fileName["fileName"]);
            return $fileName;
        }else{
            return null;
        }
    }

    public function getAllFileNameByFolders($folders)
    {
        $fileNames = array();
        $notFile = array('.','..');
        foreach ($folders as $folder) {
            if(file_exists($folder['DIR'])){
                $files = scandir($folder['DIR']);
                foreach ($files as $file) {
                    if(mb_detect_encoding($file) == 'ISO-8859-1'){
                        $file = utf8_encode($file);
                    }
                    if(!in_array($file,$notFile)){
                        $fileNames[] = $folder['DIR'].$file;
                    }
                }
            }
        }
        return $fileNames;
    }
    public function joinAttachment($relationshipAttachments,$fileNames)
    {
        $attachments = array();
        foreach ($fileNames as $set=> $fileName) {
            $attachment = \Zeedhi\DevOps\Util\Utilities::getInArrayAssoc($relationshipAttachments,$fileName,'FILENAME');
            if(!$attachment){

                $arrayDirs = explode(DIRECTORY_SEPARATOR,$fileName);
                $attachment = array(
                        'FILENAME' => $fileName,
                        'ID' => self::CREATED_BY_GEP . '_' . ($set + 1 ),
                        'LABEL' => array_pop($arrayDirs),
                        'FILE_TYPE' => 'application/x-zip-compressed',
                        'CREATED_BY' => '',
                        'CREATED_AT' => '',
                        '__fromGEP' => true,
                );
                $date = Utilities::getDataGET(array_pop($arrayDirs));
                $attachment['CREATED_AT'] = $date->format(Utilities::FORMAT_DATE_DEFAULT_ONLY_DATE);
                $attachment['CREATED_BY'] = $this->getCreatedName(array_pop($arrayDirs),$date);
            }
            $attachments[] = $attachment;
        }
        return $attachments;
    }
    public function getCreatedName($nrsoliserv,$date){
        /** @var \Teknisa\Model\Teknisa\Entities\Logfasetram $logfaseTram */
        $logfaseTram = $this->logfaseTramRepository->findOneBy(array('nrsoliserv' => $nrsoliserv, 'dtalfasetram' => $date));
        /** @var \Teknisa\Model\Geral\Entities\Operador $operador */
        $operador = $this->operadorRepository->findOneBy(array('cdoperador' => $logfaseTram->getCdoperinclusao()));
        return $operador->getNmoperador();
    }

    public function getAttachments($nrcall, $callRelationship, $filename = null)
    {
        $relationshipAttachments = array();
        if($nrcall){
            $relationshipAttachments = $this->callAttachmentRepository->getAttachmentsByCallId($nrcall);
        }

        $folders =  InstanceProvider::getRepository()->getAttachmentsLocal()->getAllAttachmentsFolder($callRelationship,
            $this->basicIntranetFileDir, null, true, $filename);

        $fileNames  = $this->getAllFileNameByFolders($folders);
        $relationshipAttachments = $this->joinAttachment($relationshipAttachments, $fileNames);
        foreach ($relationshipAttachments as &$relationshipAttachment) {
            $relationshipAttachment['FOLDER'] = '';
            foreach ($folders as $folder) {
                if(strpos($relationshipAttachment['FILENAME'],$folder['DIR']) === 0){
                    $relationshipAttachment['FOLDER'] = $folder['FILENAME'];
                    $relationshipAttachment['CALL_TYPE'] = 'S';
                }
            }
        }
        return $relationshipAttachments;

    }
}
