/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8530_SUPSTPS.sql

Descrio:
Remaneja AF's de acordo com o arredondamento para empenho.

Criao:
20/07/2004 - Joo Fernando dos Reis Corra
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
            O.NAME = 'EMPENHAR_AF' AND
            TYPE = 'P'                      AND
            U.UID = O.UID                   AND
            U.NAME = USER)
   DROP PROCEDURE EMPENHAR_AF;
GO

CREATE
PROCEDURE EMPENHAR_AF
  (@P_NRSEQAPUR    VARCHAR(10),
   @P_CDFILLANC    VARCHAR(4),
   @P_CDFILCENTCMP VARCHAR(4),
   @P_CDOPERADOR   VARCHAR(12))
AS
   DECLARE @V_IDCONSPRSOL               VARCHAR(1);

   DECLARE @V_QTAEMPENHAR               FLOAT; /* QUANTIDADE NA UNIDADE DE ESTOQUE QUE ESTA SOBRANDO NAS AF'S POR PRODUTO/FILIAL */
   DECLARE @V_QTARETIRAR                FLOAT; /* QUANTIDADE QUE SERA RETIRADA DO(S) PROXIMO(S) ITEM DE SOLICITACAO */
   DECLARE @V_NRSOLCOMP                 VARCHAR(200);
   DECLARE @V_QTSOLIPROD                FLOAT; /* QUANTIDADE DA SOLICITACAO DE COMPRAS */
   DECLARE @V_VRFATOCONV                FLOAT; /* FATOR DE CONVERSAO DO ITEM SOLICITADO */
   DECLARE @V_VRARREDEMPE               FLOAT; /* ARREDONDAMENTO PARA EMPENHO NA AF */
   DECLARE @V_QTARRED                   FLOAT; /* QUANTIDADE SOLICITADA ARREDONDADA PARA BAIXO */
   DECLARE @V_QTDISPONIVEL              FLOAT; /* QUANTIDADE DISPONIVEL PARA REMANEJAMENTO */
   DECLARE @V_DTULTENTR                 DATETIME;  /* ULTIMA ENTREGA NA APURACAO DO PRODUTO */

   DECLARE @V_PRODAEMPENHAR_CDFILIAL    VARCHAR(4);
   DECLARE @V_PRODAEMPENHAR_CDPRODESTO  VARCHAR(10);
   DECLARE @V_PRODAEMPENHAR_CDPRODUTO   VARCHAR(10);
   DECLARE @V_PRODAEMPENHAR_QTAEMPENHAR FLOAT;

   DECLARE @V_ITEMAUTF_CDFORNECED       VARCHAR(21);
   DECLARE @V_ITEMAUTF_NRAUTOFORN       VARCHAR(10);
   DECLARE @V_ITEMAUTF_DTPROGENTAF      DATETIME;
   DECLARE @V_ITEMAUTF_DTENTRITMSOL     DATETIME;
   DECLARE @V_ITEMAUTF_CDPRODUTO        VARCHAR(10);
   DECLARE @V_ITEMAUTF_CDMARCA          VARCHAR(5);
   DECLARE @V_ITEMAUTF_QTPROGENTAF      FLOAT;
   DECLARE @V_ITEMAUTF_VRFATOCONV       FLOAT;
   DECLARE @V_ITEMAUTF_VRARREDCMP       FLOAT;

   DECLARE @V_ITEMAUTF_CDARVPROD        VARCHAR(20);
   DECLARE @V_AUTOFORNE_CDFILDEST       VARCHAR(4);
   DECLARE @V_AUTOFORNE_NRAUTOFORN      VARCHAR(10);
   DECLARE @V_LISTA_AFS                 VARCHAR(20);
   DECLARE @V_LISTA_AF_AUX              NUMERIC;

   DECLARE @V_EXTRA                     VARCHAR(1);
   
   DECLARE @V_DATAINI                   DATE;
   DECLARE @V_DATAFIN                   DATE;
   DECLARE @V_DATA                      DATE;
   DECLARE @V_CONTADOR                  INTEGER;
   DECLARE @V_QTDFINAL                  NUMERIC; /* PARA CONFERIR A QUANTIDADE DA SOLICITAO*/
   DECLARE @V_QTDINTDIV                 NUMERIC; /* RECEBE O RESULTADO INTEIRO DA DIVISO*/
   DECLARE @V_REJEICAO                  NUMERIC; /* PORCENTAGEM DE REJEIO*/
   DECLARE @V_VRFATCONVAF               NUMERIC; /* FATOR DE CONVERSO DO ITEM QUE APARECER NA AF*/
   DECLARE @V_CDPRODAF                  VARCHAR(20);
   
   /*VARIVEIS DO CURSOR DE ITEMAF*/
   DECLARE @C_ITEMAF_NRAUTOFORN         VARCHAR(20);
   DECLARE @C_ITEMAF_DTPROGENTAF        DATE;
   DECLARE @C_ITEMAF_CDPRODUTO          VARCHAR(20);
   DECLARE @C_ITEMAF_CDMARCA            VARCHAR(5);
BEGIN
   SET @V_DATAINI = NULL;
   SET @V_DATAFIN = NULL;
   SELECT
      @V_IDCONSPRSOL = ISNULL(MAX(IDCONSPRSOL), 'N')
   FROM
      PARASUPRI
   WHERE
      (CDFILIAL = @P_CDFILCENTCMP);

   SELECT @V_EXTRA = MAX(IDCONSOLAPUEFET)
   FROM APURPRECO
   WHERE CDFILCENTCMP = @P_CDFILCENTCMP
     AND NRAPURPREC = @P_NRSEQAPUR;

   EXEC NOVO_CODIGO 'LISTA',  @P_SEQUENCIAL = @V_LISTA_AFS OUTPUT;
   SET @V_LISTA_AFS = SUBSTRING(@V_LISTA_AFS, 11, 10);

   IF @V_IDCONSPRSOL = 'N' BEGIN
      DECLARE C_PRODAEMPENHAR CURSOR FOR /* RETORNA OS PRODUTOS QUE TEM AF COM QUANTIDADE MAIOR QUE A DA SOLICITACAO */
        (SELECT
            CDFILIAL,
            CDPRODESTO,
            SUM(QTDECOMP) AS QTAEMPENHAR
         FROM
           (SELECT
               ITEMAUTF.CDFILDEST AS CDFILIAL,
               PRODUTO.CDPRODESTO,
               ITEMAUTF.DTENTRITMSOL,
               SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) -
               (SELECT
                   SUM(ITEMSOLI.QTSOLIPROD*P.VRFATOCONV)
                FROM
                   PRODUTO P,
                   ITEMSOLI
                WHERE
                 (ITEMSOLI.CDFILSOLI  = ITEMAUTF.CDFILDEST)    AND
                 (PRODUTO.CDPRODESTO  = P.CDPRODESTO)          AND
                 (ITEMSOLI.DTPROGENTR = ITEMAUTF.DTENTRITMSOL) AND
                 (ITEMSOLI.IDITMCONS = 'N')                    AND
                 (ITEMSOLI.CDPRODUTO = P.CDPRODUTO)            AND
                  EXISTS (SELECT 1
                          FROM SOLICITA
                          WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                            AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                            AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                            AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) ) AND
                 (ISNULL(ITEMSOLI.IDSOLIAPROV,'S') = 'S')) AS QTDECOMP
            FROM
               PRODUTO,
               ITEMAUTF,
               AUTOFORNE
            WHERE
               (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)  AND
               (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)  AND
               (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN) AND
               (ITEMAUTF.CDPRODUTO     = PRODUTO.CDPRODUTO)   AND
               (AUTOFORNE.IDSITUATUAAF IS NULL)               AND
               (AUTOFORNE.IDAFFORALIM  = 'N')                 AND
               ((AUTOFORNE.IDAUTOFORNEX = @V_EXTRA) OR (@V_EXTRA = 'X')) AND
               (ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5')       AND
               (AUTOFORNE.CDFILLANC    = @P_CDFILLANC)        AND
               (AUTOFORNE.NRSEQAPURAF  = @P_NRSEQAPUR)
            GROUP BY
               ITEMAUTF.CDFILDEST,
               PRODUTO.CDPRODESTO,
               ITEMAUTF.DTENTRITMSOL
            HAVING
               SUM(ITEMAUTF.QTPROGENTAF*PRODUTO.VRFATOCONV) >
               (SELECT
                   SUM(ITEMSOLI.QTSOLIPROD*P.VRFATOCONV)
                FROM
                   PRODUTO P,
                   ITEMSOLI
                WHERE
                   (ITEMSOLI.CDFILSOLI  = ITEMAUTF.CDFILDEST)    AND
                   (PRODUTO.CDPRODESTO  = P.CDPRODESTO)          AND
                   (ITEMSOLI.DTPROGENTR = ITEMAUTF.DTENTRITMSOL) AND
                   (ITEMSOLI.IDITMCONS  = 'N')                   AND
                   (ITEMSOLI.CDPRODUTO  = P.CDPRODUTO)           AND
                    EXISTS (SELECT 1
                            FROM SOLICITA
                            WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                              AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                              AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                              AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) ) AND
                   (ISNULL(ITEMSOLI.IDSOLIAPROV,'S') = 'S'))) A
         GROUP BY
            CDFILIAL,
            CDPRODESTO)
      OPEN C_PRODAEMPENHAR;
      FETCH NEXT FROM C_PRODAEMPENHAR INTO
         @V_PRODAEMPENHAR_CDFILIAL,
         @V_PRODAEMPENHAR_CDPRODESTO,
         @V_PRODAEMPENHAR_QTAEMPENHAR;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_QTAEMPENHAR = @V_PRODAEMPENHAR_QTAEMPENHAR;
         SET @V_QTARETIRAR  = 0;
         DECLARE C_ITEMAUTF CURSOR FOR  /* RETORNA AS DATAS DE ENTREGA DOS PRODUTOS QUE TEM QUANTIDADE A COMPRAR */
            SELECT
               AUTOFORNE.CDFORNECED,
               ITEMAUTF.NRAUTOFORN,
               ITEMAUTF.DTPROGENTAF,
               ITEMAUTF.DTENTRITMSOL,
               ITEMAUTF.CDPRODUTO,
               ITEMAUTF.CDMARCA,
               ITEMAUTF.QTPROGENTAF,
               ISNULL(PRODUTO.VRFATOCONV, 1) VRFATOCONV,
               ISNULL(PRODUTO.VRARREDCMP, 1) VRARREDCMP,
               PRODUTO.CDARVPROD
            FROM
               ITEMAUTF,
               AUTOFORNE,
               PRODUTO
            WHERE
               (AUTOFORNE.CDFILDEST   = ITEMAUTF.CDFILDEST)          AND
               (AUTOFORNE.CDFILLANC   = ITEMAUTF.CDFILLANC)          AND
               (AUTOFORNE.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)         AND
               (AUTOFORNE.CDFILLANC   = @P_CDFILLANC)                AND
               (AUTOFORNE.NRSEQAPURAF = @P_NRSEQAPUR)                AND
               (ITEMAUTF.CDFILDEST    = @V_PRODAEMPENHAR_CDFILIAL)   AND
               (ITEMAUTF.CDPRODUTO    = PRODUTO.CDPRODUTO)           AND
               (PRODUTO.CDPRODESTO    = @V_PRODAEMPENHAR_CDPRODESTO) AND
               (AUTOFORNE.IDSITUATUAAF IS NULL)                      AND
               (AUTOFORNE.IDAFFORALIM = 'N')                         AND
               ((AUTOFORNE.IDAUTOFORNEX = @V_EXTRA) OR (@V_EXTRA = 'X')) AND
               (ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5')
            ORDER BY
               ITEMAUTF.DTPROGENTAF /* ESTE "ORDER BY" E NECESSARIO */
         OPEN C_ITEMAUTF;
         FETCH NEXT FROM C_ITEMAUTF INTO
            @V_ITEMAUTF_CDFORNECED,
            @V_ITEMAUTF_NRAUTOFORN,
            @V_ITEMAUTF_DTPROGENTAF,
            @V_ITEMAUTF_DTENTRITMSOL,
            @V_ITEMAUTF_CDPRODUTO,
            @V_ITEMAUTF_CDMARCA,
            @V_ITEMAUTF_QTPROGENTAF,
            @V_ITEMAUTF_VRFATOCONV,
            @V_ITEMAUTF_VRARREDCMP,
            @V_ITEMAUTF_CDARVPROD;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF (@V_QTARETIRAR > 0) AND (@V_PRODAEMPENHAR_QTAEMPENHAR >= @V_QTARETIRAR) BEGIN  /* SE ALGUM ITEM DE SOLICITACAO TEVE SUA QUANTIDADE AUMENTADA, ESTE "IF" IRA COMPLETAR O REMANEJAMENTO DIMINUINDO A QUANTIDADE */
               SET @V_NRSOLCOMP = NULL;
               SELECT
                  @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
               FROM
                  ITEMSOLI,
                  PRODUTO
               WHERE
                  (ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO)         AND
                  (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL) AND
                  (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL)  AND
                   EXISTS (SELECT 1
                           FROM SOLICITA
                           WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                             AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                             AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                             AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) ) AND
                  (PRODUTO.CDPRODESTO  = @V_PRODAEMPENHAR_CDPRODESTO);

               SET @V_QTSOLIPROD = NULL;
               SELECT
                  @V_QTSOLIPROD = MAX(ITEMSOLI.QTSOLIPROD * PRODUTO.VRFATOCONV)
               FROM
                  ITEMSOLI,
                  PRODUTO
               WHERE
                  (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                  (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                  (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                  (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                  (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL)        AND
                  (ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO);

               IF @V_QTSOLIPROD <= @V_QTARETIRAR BEGIN /* O ITEM DA SOLICITACAO SERA EXCLUIDO CASO TENHA QUE RETIRAR UMA QUANTIDADE MAIOR QUE A SUA PROPRIA */
                  /* LOG DE ALTERAO */
                  INSERT INTO MOVOPSOL
                    (CDFILSOLMOV,
                     CDFILLANMOV,
                     NRSOLIMOV,
                     CDPRODUTO,
                     DTENTROPER,
                     DTOPERSOL,
                     CDOPERADOR,
                     QTANTOPER,
                     QTDEPOPER,
                     DSJUSTOPER)
                  VALUES
                    (@V_PRODAEMPENHAR_CDFILIAL,
                     SUBSTRING(@V_NRSOLCOMP, 11, 4),
                     SUBSTRING(@V_NRSOLCOMP, 1, 10),
                     SUBSTRING(@V_NRSOLCOMP, 15, 10),
                     @V_ITEMAUTF_DTENTRITMSOL,
                     GETDATE(),
                     @P_CDOPERADOR,
                     @V_QTSOLIPROD,
                     0,
                     'Empenho de AF');

                  DELETE FROM ITEMSOLI
                  WHERE
                     (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  DELETE FROM ITEMAUTF
                  WHERE
                     (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL) AND
                     (CDFILLANC   = @P_CDFILLANC)              AND
                     (NRAUTOFORN  = @V_ITEMAUTF_NRAUTOFORN)    AND
                     (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)     AND
                     (CDMARCA     = @V_ITEMAUTF_CDMARCA)       AND
                     (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF);

                  SET @V_LISTA_AF_AUX = 0;

                  SELECT
                     @V_LISTA_AF_AUX = COUNT(*)
                  FROM
                     LISTA
                  WHERE
                     NRLISTA = @V_LISTA_AFS AND
                     CDLISTA = @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN;

                  IF @V_LISTA_AF_AUX = 0 BEGIN
                     INSERT INTO LISTA
                     (NRLISTA, CDLISTA)
                     VALUES
                     (@V_LISTA_AFS, @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN);
                  END;

                  SET @V_QTARETIRAR  = @V_QTARETIRAR - @V_QTSOLIPROD;
                  SET @V_QTAEMPENHAR = @V_QTAEMPENHAR - (@V_ITEMAUTF_QTPROGENTAF * @V_ITEMAUTF_VRFATOCONV);
               END
               ELSE BEGIN
                  SET @V_VRFATOCONV = NULL;
                  SELECT
                     @V_VRFATOCONV = MAX(PRODUTO.VRFATOCONV)
                  FROM
                     ITEMSOLI,
                     PRODUTO
                  WHERE
                     (ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO)               AND
                     (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  /* LOG DE ALTERAO */
                  INSERT INTO MOVOPSOL
                    (CDFILSOLMOV,
                     CDFILLANMOV,
                     NRSOLIMOV,
                     CDPRODUTO,
                     DTENTROPER,
                     DTOPERSOL,
                     CDOPERADOR,
                     QTANTOPER,
                     QTDEPOPER,
                     DSJUSTOPER)
                  SELECT
                     ITEMSOLI.CDFILSOLI,
                     ITEMSOLI.CDFILLAN,
                     ITEMSOLI.NRSOLICMP,
                     ITEMSOLI.CDPRODUTO,
                     ITEMSOLI.DTPROGENTR,
                     GETDATE(),
                     @P_CDOPERADOR,
                     ITEMSOLI.QTSOLIPROD,
                     ITEMSOLI.QTSOLIPROD - @V_QTARETIRAR/@V_VRFATOCONV,
                     'Empenho de AF'
                  FROM
                     ITEMSOLI
                  WHERE
                     (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  UPDATE ITEMSOLI
                  SET QTSOLIPROD = QTSOLIPROD - @V_QTARETIRAR/@V_VRFATOCONV
                  WHERE
                     (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  SET @V_QTARETIRAR = 0;
               END;
            END;

            IF @V_QTARETIRAR = 0 BEGIN  /* SE O REMANEJAMENTO DAS ENTREGAS ANTERIORES FOI FINALIZADO NO "IF" ACIMA, ESTE "IF" IRA VERIFICAR SE SERA NECESSARIO FAZER OUTRO REMANEJAMENTO PUXANDO DE ENTREGAS FUTURAS */
               SET @V_NRSOLCOMP = NULL;
               SELECT
                  @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
               FROM
                  ITEMSOLI,
                  PRODUTO
               WHERE
                  (ITEMSOLI.CDPRODUTO   = PRODUTO.CDPRODUTO)         AND
                  (ITEMSOLI.CDFILSOLI   = @V_PRODAEMPENHAR_CDFILIAL) AND
                  (ITEMSOLI.DTPROGENTR  = @V_ITEMAUTF_DTENTRITMSOL)  AND
                   EXISTS (SELECT 1
                           FROM SOLICITA
                           WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                             AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                             AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                             AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) ) AND
                  (PRODUTO.CDPRODESTO   = @V_PRODAEMPENHAR_CDPRODESTO);

               IF @V_NRSOLCOMP IS NOT NULL BEGIN  /* SE AINDA EXITIR SOLICITACAO PARA ESTA ENTREGA... */
                  SET @V_QTSOLIPROD = NULL;
                  SELECT
                     @V_QTSOLIPROD = MAX(ITEMSOLI.QTSOLIPROD * PRODUTO.VRFATOCONV)
                  FROM
                     ITEMSOLI,
                     PRODUTO
                  WHERE
                     (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL)        AND
                     (ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO);

                  SET @V_QTARETIRAR = (@V_ITEMAUTF_QTPROGENTAF * @V_ITEMAUTF_VRFATOCONV) - @V_QTSOLIPROD;

                  IF (@V_QTARETIRAR > 0) AND (@V_PRODAEMPENHAR_QTAEMPENHAR >= @V_QTARETIRAR) BEGIN

/*################################ AJUSTANDO V_QTARETIRAR PARA O VALOR QUE TEM DISPONIVEL PARA REMANEJAR ###############################*/
                     SET @V_DTULTENTR = NULL;
                     SELECT
                        @V_DTULTENTR = MAX(ITEMAUTF.DTENTRITMSOL)
                     FROM
                        ITEMAUTF,
                        AUTOFORNE
                     WHERE
                        (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)        AND
                        (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)        AND
                        (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN)       AND
                        (ITEMAUTF.CDPRODUTO     = @V_ITEMAUTF_CDPRODUTO)     AND
                        (ITEMAUTF.CDFILDEST     = @V_PRODAEMPENHAR_CDFILIAL) AND
                        (AUTOFORNE.IDSITUATUAAF IS NULL)                     AND
                        (AUTOFORNE.IDAFFORALIM  = 'N')                       AND
                        ((AUTOFORNE.IDAUTOFORNEX = @V_EXTRA) OR (@V_EXTRA = 'X')) AND
                        (ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5')             AND
                        (AUTOFORNE.CDFILLANC    = @P_CDFILLANC)              AND
                        (AUTOFORNE.NRSEQAPURAF  = @P_NRSEQAPUR);

                     SET @V_QTDISPONIVEL = NULL;
                     SELECT
                        @V_QTDISPONIVEL = SUM(ITEMSOLI.QTSOLIPROD * PRODUTO.VRFATOCONV)
                     FROM
                        ITEMSOLI,
                        PRODUTO
                     WHERE
                        (ITEMSOLI.CDFILSOLI  =  @V_PRODAEMPENHAR_CDFILIAL)   AND
                        (PRODUTO.CDPRODESTO  =  @V_PRODAEMPENHAR_CDPRODESTO) AND
                        (ITEMSOLI.DTPROGENTR >  @V_ITEMAUTF_DTENTRITMSOL)    AND
                        (ITEMSOLI.DTPROGENTR <= @V_DTULTENTR)                AND
                         EXISTS (SELECT 1
                                 FROM SOLICITA
                                 WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                                   AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                                   AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                                   AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) ) AND
                        (ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO);

                     IF ISNULL(@V_QTDISPONIVEL, 0) > 0 BEGIN
                        IF @V_QTARETIRAR > ISNULL(@V_QTDISPONIVEL, 0) BEGIN
                           SET @V_QTARETIRAR = ISNULL(@V_QTDISPONIVEL, 0);
                        END;
                     END;

                     SET @V_QTARRED = @V_QTARETIRAR/@V_ITEMAUTF_VRFATOCONV;
                     IF @V_ITEMAUTF_VRARREDCMP > 0 BEGIN
                        SET @V_QTARRED = FLOOR(@V_QTARRED / @V_ITEMAUTF_VRARREDCMP) * @V_ITEMAUTF_VRARREDCMP; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                     END;

                     SET @V_VRARREDEMPE = 0;

                     SELECT
                        @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPMAR), 0)
                     FROM
                        MARCPROD
                     WHERE
                        (CDMARCA   = @V_ITEMAUTF_CDMARCA) AND
                        (CDPRODUTO IN (SELECT
                                          P.CDPRODUTO
                                       FROM
                                          PRODUTO P
                                       WHERE
                                          P.CDPRODUTO = MARCPROD.CDPRODUTO AND
                                          @V_ITEMAUTF_CDARVPROD LIKE P.CDARVPROD + '%') );

                     IF @V_VRARREDEMPE = 0 BEGIN
                        SELECT
                           @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPE), 0)
                        FROM
                           PRODFORNCOMP
                        WHERE
                           (CDFORNECED  = @V_ITEMAUTF_CDFORNECED) AND
                           (CDPRODCOMPL = @V_ITEMAUTF_CDPRODUTO);
                     END;

                     IF @V_VRARREDEMPE > 0 BEGIN
                        SET @V_QTARRED = FLOOR(@V_QTARRED / @V_VRARREDEMPE) * @V_VRARREDEMPE; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                     END;

                     IF @V_QTARRED > 0 BEGIN
                        UPDATE ITEMAUTF
                        SET QTPROGENTAF = QTPROGENTAF - @V_QTARRED
                        WHERE
                           (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL) AND
                           (CDFILLANC   = @P_CDFILLANC)              AND
                           (NRAUTOFORN  = @V_ITEMAUTF_NRAUTOFORN)    AND
                           (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)     AND
                           (CDMARCA     = @V_ITEMAUTF_CDMARCA)       AND
                           (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF);

                        SET @V_LISTA_AF_AUX = 0;

                        SELECT
                           @V_LISTA_AF_AUX = COUNT(*)
                        FROM
                           LISTA
                        WHERE
                           NRLISTA = @V_LISTA_AFS AND
                           CDLISTA = @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN;

                        IF @V_LISTA_AF_AUX = 0 BEGIN
                           INSERT INTO LISTA
                           (NRLISTA, CDLISTA)
                           VALUES
                           (@V_LISTA_AFS, @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN);
                        END;

                        SET @V_QTAEMPENHAR = @V_QTAEMPENHAR - (@V_QTARRED * @V_ITEMAUTF_VRFATOCONV);
                        SET @V_QTARETIRAR  = @V_QTARETIRAR - (@V_QTARRED * @V_ITEMAUTF_VRFATOCONV);
                     END;

                     IF (@V_QTARETIRAR > 0) AND (@V_PRODAEMPENHAR_QTAEMPENHAR >= @V_QTARETIRAR) BEGIN
                        IF @V_QTARETIRAR <= @V_QTAEMPENHAR BEGIN
                           SET @V_VRFATOCONV = NULL;
                           SELECT
                              @V_VRFATOCONV = MAX(PRODUTO.VRFATOCONV)
                           FROM
                              ITEMSOLI,
                              PRODUTO
                           WHERE
                             (ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO)               AND
                             (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                             (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                             (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                             (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                             (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                           /* LOG DE ALTERAO */
                           INSERT INTO MOVOPSOL
                             (CDFILSOLMOV,
                              CDFILLANMOV,
                              NRSOLIMOV,
                              CDPRODUTO,
                              DTENTROPER,
                              DTOPERSOL,
                              CDOPERADOR,
                              QTANTOPER,
                              QTDEPOPER,
                              DSJUSTOPER)
                           SELECT
                              ITEMSOLI.CDFILSOLI,
                              ITEMSOLI.CDFILLAN,
                              ITEMSOLI.NRSOLICMP,
                              ITEMSOLI.CDPRODUTO,
                              ITEMSOLI.DTPROGENTR,
                              GETDATE(),
                              @P_CDOPERADOR,
                              ITEMSOLI.QTSOLIPROD,
                              ITEMSOLI.QTSOLIPROD + @V_QTARETIRAR/@V_VRFATOCONV,
                             'Empenho de AF'
                           FROM
                              ITEMSOLI
                           WHERE
                              (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                              (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                              (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                              (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                              (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                           UPDATE ITEMSOLI
                           SET QTSOLIPROD = QTSOLIPROD + @V_QTARETIRAR/@V_VRFATOCONV
                           WHERE
                              (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                              (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                              (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                              (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                              (DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);
                        END;
                     END;
                  END;
               END;
            END;
            --DEFINE AS DATAS FINAL E INICIAL DO PERIODO APURADO NO CURSOR C_ITEMAUTF
            IF (@V_DATAINI IS NULL) BEGIN
               SET @V_DATAINI = @V_ITEMAUTF_DTENTRITMSOL;
            END;
            SET @V_DATAFIN = @V_ITEMAUTF_DTENTRITMSOL; --PEGA A LTIMA DATA, A MAIOR
            SET @V_VRFATCONVAF = @V_ITEMAUTF_VRFATOCONV;
            SET @V_CDPRODAF    = @V_ITEMAUTF_CDPRODUTO;
            
            FETCH NEXT FROM C_ITEMAUTF INTO
               @V_ITEMAUTF_CDFORNECED,
               @V_ITEMAUTF_NRAUTOFORN,
               @V_ITEMAUTF_DTPROGENTAF,
               @V_ITEMAUTF_DTENTRITMSOL,
               @V_ITEMAUTF_CDPRODUTO,
               @V_ITEMAUTF_CDMARCA,
               @V_ITEMAUTF_QTPROGENTAF,
               @V_ITEMAUTF_VRFATOCONV,
               @V_ITEMAUTF_VRARREDCMP,
               @V_ITEMAUTF_CDARVPROD;
         END;
         CLOSE C_ITEMAUTF;
         DEALLOCATE C_ITEMAUTF;
         -- Fazer as alteraes aqui
         SET @V_CONTADOR = DATEDIFF(DAY, @V_DATAFIN, @V_DATAINI);
         WHILE @V_CONTADOR >= 0 BEGIN
            SET @V_DATA = DATEADD(DD, @V_CONTADOR, @V_DATAINI);
            SELECT
               @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
            FROM
               ITEMSOLI,
               PRODUTO
            WHERE
               (ITEMSOLI.CDPRODUTO  = PRODUTO.CDPRODUTO)        AND
               (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL) AND
               (ITEMSOLI.DTPROGENTR = @V_DATA)  AND
               ((ITEMSOLI.IDITMSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) AND
               (PRODUTO.CDPRODESTO  = @V_PRODAEMPENHAR_CDPRODESTO);
            IF @@ROWCOUNT = 0 BEGIN
               SET @V_NRSOLCOMP = NULL;
            END;
            
            IF (@V_NRSOLCOMP IS NOT NULL) BEGIN
               SELECT @V_QTDFINAL = CAST((ITEMSOLI.QTSOLIPROD) AS NUMERIC)%@V_VRFATCONVAF,
                      @V_QTDINTDIV = FLOOR(CAST((ITEMSOLI.QTSOLIPROD) AS NUMERIC)/@V_VRFATCONVAF)
               FROM ITEMSOLI
               WHERE
                  (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                  (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                  (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                  (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                  (ITEMSOLI.DTPROGENTR = @V_DATA);
               -- BUSCA O VALOR MINIMO DE REJEICAO 
               SELECT @V_REJEICAO = ISNULL(VRMINEMPENHOAF, 0)
               FROM PRODFILI
               WHERE CDFILIAL  = @V_PRODAEMPENHAR_CDFILIAL -- FILIAL SOLICITANTE
                 AND CDPRODUTO = @V_CDPRODAF;
               IF @V_QTDFINAL IS NOT NULL BEGIN
                  IF (@V_QTDFINAL > 0) AND (@V_QTDFINAL < (@V_VRFATCONVAF*@V_REJEICAO)) BEGIN
                     UPDATE ITEMSOLI
                     SET QTSOLIPROD = QTSOLIPROD - @V_QTDFINAL
                     WHERE
                        (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)    AND
                        (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                        (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                        (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                        (@V_QTDINTDIV >= 1) AND
                        (DTPROGENTR = @V_DATA);
                     IF @@ROWCOUNT = 0 BEGIN
                        DELETE FROM ITEMSOLI
                        WHERE
                           (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)    AND
                           (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                           (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                           (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                           (DTPROGENTR = @V_DATA);
                     END;
                     DECLARE C_ITEMAF CURSOR FOR /*DADOS DA AF A SER UPDATADA OU DELETADA*/
                     (
                        SELECT ITF.NRAUTOFORN, ITF.DTPROGENTAF, ITF.CDPRODUTO, ITF.CDMARCA
                        FROM ITEMAUTF ITF, PRODUTO P
                        WHERE ITF.CDFILLANC    = SUBSTRING(@V_NRSOLCOMP, 11, 4)
                          AND ITF.CDFILDEST    = @V_PRODAEMPENHAR_CDFILIAL
                          AND ITF.DTENTRITMSOL = @V_DATA
                          AND ITF.CDPRODUTO    = P.CDPRODUTO
                          AND P.CDPRODESTO     = @V_PRODAEMPENHAR_CDPRODESTO
                     )
                     OPEN C_ITEMAF;
                     FETCH NEXT FROM C_ITEMAF INTO
                        @C_ITEMAF_NRAUTOFORN,
                        @C_ITEMAF_DTPROGENTAF,
                        @C_ITEMAF_CDPRODUTO,
                        @C_ITEMAF_CDMARCA;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        UPDATE ITEMAUTF
                        SET QTPROGENTAF = QTPROGENTAF - 1
                        WHERE
                           (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL)   AND
                           (CDFILLANC   = SUBSTRING(@V_NRSOLCOMP, 11, 4)) AND
                           (NRAUTOFORN  = @C_ITEMAF_NRAUTOFORN)        AND
                           (CDPRODUTO   = @C_ITEMAF_CDPRODUTO)         AND
                           (CDMARCA     = @C_ITEMAF_CDMARCA)           AND
                           (DTPROGENTAF = @C_ITEMAF_DTPROGENTAF)       AND
                           (QTPROGENTAF > 1);
                        IF @@ROWCOUNT = 0 BEGIN
                           DELETE FROM ITEMAUTF
                           WHERE
                              (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL)   AND
                              (CDFILLANC   = SUBSTRING(@V_NRSOLCOMP, 11, 4)) AND
                              (NRAUTOFORN  = @C_ITEMAF_NRAUTOFORN)        AND
                              (CDPRODUTO   = @C_ITEMAF_CDPRODUTO)         AND
                              (CDMARCA     = @C_ITEMAF_CDMARCA)           AND
                              (DTPROGENTAF = @C_ITEMAF_DTPROGENTAF);
                        END;
                        FETCH NEXT FROM C_ITEMAF INTO
                           @C_ITEMAF_NRAUTOFORN,
                           @C_ITEMAF_DTPROGENTAF,
                           @C_ITEMAF_CDPRODUTO,
                           @C_ITEMAF_CDMARCA;
                     END;
                     CLOSE C_ITEMAF;
                     DEALLOCATE C_ITEMAF;
                  END;
               END;               
            END;
            SET @V_CONTADOR = @V_CONTADOR - 1;
         END;
         FETCH NEXT FROM C_PRODAEMPENHAR INTO
            @V_PRODAEMPENHAR_CDFILIAL,
            @V_PRODAEMPENHAR_CDPRODESTO,
            @V_PRODAEMPENHAR_QTAEMPENHAR;
      END;
      CLOSE C_PRODAEMPENHAR;
      DEALLOCATE C_PRODAEMPENHAR;
   END;
   IF @V_IDCONSPRSOL = 'S' BEGIN
      DECLARE C_PRODAEMPENHAR CURSOR FOR /* RETORNA OS PRODUTOS QUE TEM AF COM QUANTIDADE MAIOR QUE A DA SOLICITACAO */
        (SELECT
            CDFILIAL,
            CDPRODUTO,
            SUM(QTDECOMP) AS QTAEMPENHAR
         FROM
           (SELECT
               ITEMAUTF.CDFILDEST AS CDFILIAL,
               ITEMAUTF.CDPRODUTO,
               ITEMAUTF.DTENTRITMSOL,
               SUM(ITEMAUTF.QTPROGENTAF) -
               (SELECT
                   SUM(ITEMSOLI.QTSOLIPROD)
                FROM
                   ITEMSOLI
                WHERE
                   (ITEMSOLI.CDFILSOLI  = ITEMAUTF.CDFILDEST)    AND
                   (ITEMSOLI.DTPROGENTR = ITEMAUTF.DTENTRITMSOL) AND
                   (ITEMSOLI.IDITMCONS = 'N')                    AND
                   (ITEMSOLI.CDPRODUTO = ITEMAUTF.CDPRODUTO)     AND
                    EXISTS (SELECT 1
                            FROM SOLICITA
                            WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                              AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                              AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                              AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) ) AND
                   (ISNULL(ITEMSOLI.IDSOLIAPROV,'S') = 'S')) AS QTDECOMP
                FROM
                   ITEMAUTF,
                   AUTOFORNE
                WHERE
                   (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)  AND
                   (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)  AND
                   (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN) AND
                   (AUTOFORNE.IDSITUATUAAF IS NULL)               AND
                   (AUTOFORNE.IDAFFORALIM  = 'N')                 AND
                   ((AUTOFORNE.IDAUTOFORNEX = @V_EXTRA) OR (@V_EXTRA = 'X')) AND
                   (ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5')       AND
                   (AUTOFORNE.CDFILLANC    = @P_CDFILLANC)        AND
                   (AUTOFORNE.NRSEQAPURAF  = @P_NRSEQAPUR)
               GROUP BY
                  ITEMAUTF.CDFILDEST,
                  ITEMAUTF.CDPRODUTO,
                  ITEMAUTF.DTENTRITMSOL
               HAVING
                  SUM(ITEMAUTF.QTPROGENTAF) >
                  (SELECT
                      SUM(ITEMSOLI.QTSOLIPROD)
                   FROM
                      ITEMSOLI
                   WHERE
                      (ITEMSOLI.CDFILSOLI  = ITEMAUTF.CDFILDEST)    AND
                      (ITEMSOLI.DTPROGENTR = ITEMAUTF.DTENTRITMSOL) AND
                      (ITEMSOLI.IDITMCONS = 'N')                    AND
                      (ITEMSOLI.CDPRODUTO = ITEMAUTF.CDPRODUTO)     AND
                       EXISTS (SELECT 1
                               FROM SOLICITA
                               WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                                 AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                                 AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                                 AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) )                                     AND
                      (ISNULL(ITEMSOLI.IDSOLIAPROV,'S') = 'S'))) A
         GROUP BY
            CDFILIAL,
            CDPRODUTO)
      OPEN C_PRODAEMPENHAR;
      FETCH NEXT FROM C_PRODAEMPENHAR INTO
         @V_PRODAEMPENHAR_CDFILIAL,
         @V_PRODAEMPENHAR_CDPRODUTO,
         @V_PRODAEMPENHAR_QTAEMPENHAR;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_QTAEMPENHAR = @V_PRODAEMPENHAR_QTAEMPENHAR;
         SET @V_QTARETIRAR  = 0;
         DECLARE C_ITEMAUTF CURSOR FOR  /* RETORNA AS DATAS DE ENTREGA DOS PRODUTOS QUE TEM QUANTIDADE A COMPRAR */
            SELECT
               AUTOFORNE.CDFORNECED,
               ITEMAUTF.NRAUTOFORN,
               ITEMAUTF.DTPROGENTAF,
               ITEMAUTF.DTENTRITMSOL,
               ITEMAUTF.CDPRODUTO,
               ITEMAUTF.CDMARCA,
               ITEMAUTF.QTPROGENTAF,
               ISNULL(PRODUTO.VRFATOCONV, 1) VRFATOCONV,
               ISNULL(PRODUTO.VRARREDCMP, 1) VRARREDCMP,
               PRODUTO.CDARVPROD
            FROM
               ITEMAUTF,
               AUTOFORNE,
               PRODUTO
            WHERE
               (AUTOFORNE.CDFILDEST   = ITEMAUTF.CDFILDEST)         AND
               (AUTOFORNE.CDFILLANC   = ITEMAUTF.CDFILLANC)         AND
               (AUTOFORNE.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)        AND
               (AUTOFORNE.CDFILLANC   = @P_CDFILLANC)               AND
               (AUTOFORNE.NRSEQAPURAF = @P_NRSEQAPUR)               AND
               (ITEMAUTF.CDFILDEST    = @V_PRODAEMPENHAR_CDFILIAL)  AND
               (ITEMAUTF.CDPRODUTO    = PRODUTO.CDPRODUTO)          AND
               (PRODUTO.CDPRODUTO     = @V_PRODAEMPENHAR_CDPRODUTO) AND
               (AUTOFORNE.IDSITUATUAAF IS NULL)                     AND
               (AUTOFORNE.IDAFFORALIM  = 'N')                       AND
               ((AUTOFORNE.IDAUTOFORNEX = @V_EXTRA) OR (@V_EXTRA = 'X')) AND
               (ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5')
            ORDER BY
               ITEMAUTF.DTPROGENTAF /* ESTE "ORDER BY" E NECESSARIO */
         OPEN C_ITEMAUTF;
         FETCH NEXT FROM C_ITEMAUTF INTO
            @V_ITEMAUTF_CDFORNECED,
            @V_ITEMAUTF_NRAUTOFORN,
            @V_ITEMAUTF_DTPROGENTAF,
            @V_ITEMAUTF_DTENTRITMSOL,
            @V_ITEMAUTF_CDPRODUTO,
            @V_ITEMAUTF_CDMARCA,
            @V_ITEMAUTF_QTPROGENTAF,
            @V_ITEMAUTF_VRFATOCONV,
            @V_ITEMAUTF_VRARREDCMP,
            @V_ITEMAUTF_CDARVPROD;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF (@V_QTARETIRAR > 0) AND (@V_PRODAEMPENHAR_QTAEMPENHAR >= @V_QTARETIRAR) BEGIN  /* SE ALGUM ITEM DE SOLICITACAO TEVE SUA QUANTIDADE AUMENTADA, ESTE "IF" IRA COMPLETAR O REMANEJAMENTO DIMINUINDO A QUANTIDADE */
               SET @V_NRSOLCOMP = NULL;
               SELECT
                  @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
               FROM
                  ITEMSOLI
               WHERE
                  (ITEMSOLI.CDPRODUTO  = @V_PRODAEMPENHAR_CDPRODUTO) AND
                  (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)  AND
                   EXISTS (SELECT 1
                           FROM SOLICITA
                           WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                             AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                             AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                             AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) )                                     AND
                  (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

               SET @V_QTSOLIPROD = NULL;
               SELECT
                  @V_QTSOLIPROD = MAX(ITEMSOLI.QTSOLIPROD)
               FROM
                  ITEMSOLI
               WHERE
                  (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                  (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                  (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                  (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                  (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

               IF @V_QTSOLIPROD <= @V_QTARETIRAR BEGIN /* O ITEM DA SOLICITACAO SERA EXCLUIDO CASO TENHA QUE RETIRAR UMA QUANTIDADE MAIOR QUE A SUA PROPRIA */
                  /* LOG DE ALTERAO */
                  INSERT INTO MOVOPSOL
                    (CDFILSOLMOV,
                     CDFILLANMOV,
                     NRSOLIMOV,
                     CDPRODUTO,
                     DTENTROPER,
                     DTOPERSOL,
                     CDOPERADOR,
                     QTANTOPER,
                     QTDEPOPER,
                     DSJUSTOPER)
                  VALUES
                    (@V_PRODAEMPENHAR_CDFILIAL,
                     SUBSTRING(@V_NRSOLCOMP, 11, 4),
                     SUBSTRING(@V_NRSOLCOMP, 1, 10),
                     SUBSTRING(@V_NRSOLCOMP, 15, 10),
                     @V_ITEMAUTF_DTENTRITMSOL,
                     GETDATE(),
                     @P_CDOPERADOR,
                     @V_QTSOLIPROD,
                     0,
                     'Empenho de AF');

                  DELETE FROM ITEMSOLI
                  WHERE
                     (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  DELETE FROM ITEMAUTF
                  WHERE
                     (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL) AND
                     (CDFILLANC   = @P_CDFILLANC)              AND
                     (NRAUTOFORN  = @V_ITEMAUTF_NRAUTOFORN)    AND
                     (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)     AND
                     (CDMARCA     = @V_ITEMAUTF_CDMARCA)       AND
                     (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF);

                  SET @V_LISTA_AF_AUX = 0;

                  SELECT
                     @V_LISTA_AF_AUX = COUNT(*)
                  FROM
                     LISTA
                  WHERE
                     NRLISTA = @V_LISTA_AFS AND
                     CDLISTA = @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN;

                  IF @V_LISTA_AF_AUX = 0 BEGIN
                     INSERT INTO LISTA
                     (NRLISTA, CDLISTA)
                     VALUES
                     (@V_LISTA_AFS, @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN);
                  END;

                  SET @V_QTARETIRAR  = @V_QTARETIRAR - @V_QTSOLIPROD;
                  SET @V_QTAEMPENHAR = @V_QTAEMPENHAR - @V_ITEMAUTF_QTPROGENTAF;
               END
               ELSE BEGIN
                  /* LOG DE ALTERAO */
                  INSERT INTO MOVOPSOL
                    (CDFILSOLMOV,
                     CDFILLANMOV,
                     NRSOLIMOV,
                     CDPRODUTO,
                     DTENTROPER,
                     DTOPERSOL,
                     CDOPERADOR,
                     QTANTOPER,
                     QTDEPOPER,
                     DSJUSTOPER)
                  SELECT
                     ITEMSOLI.CDFILSOLI,
                     ITEMSOLI.CDFILLAN,
                     ITEMSOLI.NRSOLICMP,
                     ITEMSOLI.CDPRODUTO,
                     ITEMSOLI.DTPROGENTR,
                     GETDATE(),
                     @P_CDOPERADOR,
                     ITEMSOLI.QTSOLIPROD,
                     ITEMSOLI.QTSOLIPROD - @V_QTARETIRAR,
                     'Empenho de AF'
                  FROM
                     ITEMSOLI
                  WHERE
                     (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  UPDATE ITEMSOLI
                  SET QTSOLIPROD = QTSOLIPROD - @V_QTARETIRAR
                  WHERE
                    (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                    (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                    (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                    (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                    (DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  SET @V_QTARETIRAR = 0;
               END;
            END;

            IF @V_QTARETIRAR = 0 BEGIN  /* SE O REMANEJAMENTO DAS ENTREGAS ANTERIORES FOI FINALIZADO NO "IF" ACIMA, ESTE "IF" IRA VERIFICAR SE SERA NECESSARIO FAZER OUTRO REMANEJAMENTO PUXANDO DE ENTREGAS FUTURAS */
               SET @V_NRSOLCOMP = NULL;
               SELECT
                  @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
               FROM
                  ITEMSOLI
               WHERE
                  (ITEMSOLI.CDPRODUTO   = @V_PRODAEMPENHAR_CDPRODUTO) AND
                  (ITEMSOLI.CDFILSOLI   = @V_PRODAEMPENHAR_CDFILIAL)  AND
                   EXISTS (SELECT 1
                           FROM SOLICITA
                           WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                             AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                             AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                             AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) )                                     AND
                  (ITEMSOLI.DTPROGENTR  = @V_ITEMAUTF_DTENTRITMSOL);

               IF @V_NRSOLCOMP IS NOT NULL BEGIN  /* SE AINDA EXITIR SOLICITACAO PARA ESTA ENTREGA... */

                  SET @V_QTSOLIPROD = NULL;
                  SELECT
                     @V_QTSOLIPROD = MAX(ITEMSOLI.QTSOLIPROD)
                  FROM
                     ITEMSOLI
                  WHERE
                     (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                     (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                     (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                     (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                     (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                  SET @V_QTARETIRAR = @V_ITEMAUTF_QTPROGENTAF - @V_QTSOLIPROD;

                  IF (@V_QTARETIRAR > 0) AND (@V_PRODAEMPENHAR_QTAEMPENHAR >= @V_QTARETIRAR) BEGIN

/*################################ AJUSTANDO V_QTARETIRAR PARA O VALOR QUE TEM DISPONIVEL PARA REMANEJAR ###############################*/
                     SET @V_DTULTENTR = NULL;
                     SELECT
                        @V_DTULTENTR = MAX(ITEMAUTF.DTENTRITMSOL)
                     FROM
                        ITEMAUTF, AUTOFORNE
                     WHERE
                        (AUTOFORNE.CDFILDEST    = ITEMAUTF.CDFILDEST)        AND
                        (AUTOFORNE.CDFILLANC    = ITEMAUTF.CDFILLANC)        AND
                        (AUTOFORNE.NRAUTOFORN   = ITEMAUTF.NRAUTOFORN)       AND
                        (ITEMAUTF.CDPRODUTO     = @V_ITEMAUTF_CDPRODUTO)     AND
                        (ITEMAUTF.CDFILDEST     = @V_PRODAEMPENHAR_CDFILIAL) AND
                        (AUTOFORNE.IDSITUATUAAF IS NULL)                     AND
                        (AUTOFORNE.IDAFFORALIM  = 'N')                       AND
                        ((AUTOFORNE.IDAUTOFORNEX = @V_EXTRA) OR (@V_EXTRA = 'X')) AND
                        (ISNULL(AUTOFORNE.IDBAIXAAF,'0') <> '5')             AND
                        (AUTOFORNE.CDFILLANC    = @P_CDFILLANC)             AND
                        (AUTOFORNE.NRSEQAPURAF  = @P_NRSEQAPUR);

                     SET @V_QTDISPONIVEL = NULL;
                     SELECT
                        @V_QTDISPONIVEL = SUM(ITEMSOLI.QTSOLIPROD)
                     FROM
                        ITEMSOLI
                     WHERE
                        (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL) AND
                        (ITEMSOLI.DTPROGENTR > @V_ITEMAUTF_DTENTRITMSOL)  AND
                        (ITEMSOLI.DTPROGENTR <= @V_DTULTENTR)             AND
                         EXISTS (SELECT 1
                                 FROM SOLICITA
                                 WHERE SOLICITA.CDFILSOLI  = ITEMSOLI.CDFILSOLI
                                   AND SOLICITA.CDFILLANCA = ITEMSOLI.CDFILLAN
                                   AND SOLICITA.NRSOLICMP  = ITEMSOLI.NRSOLICMP
                                   AND ((SOLICITA.IDSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X')) )                                     AND
                        (ITEMSOLI.CDPRODUTO  = @V_PRODAEMPENHAR_CDPRODUTO);

                     IF ISNULL(@V_QTDISPONIVEL, 0) > 0 BEGIN
                        IF @V_QTARETIRAR > ISNULL(@V_QTDISPONIVEL, 0) BEGIN
                           SET @V_QTARETIRAR = ISNULL(@V_QTDISPONIVEL, 0);
                        END;
                     END;

                     SET @V_QTARRED = @V_QTARETIRAR;
                     IF @V_ITEMAUTF_VRARREDCMP > 0 BEGIN
                        SET @V_QTARRED = FLOOR(@V_QTARRED / @V_ITEMAUTF_VRARREDCMP) * @V_ITEMAUTF_VRARREDCMP; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                     END;

                     SET @V_VRARREDEMPE = 0;

                     SELECT
                        @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPMAR), 0)
                     FROM
                        MARCPROD
                     WHERE
                        (CDMARCA   = @V_ITEMAUTF_CDMARCA) AND
                        (CDPRODUTO IN (SELECT
                                          P.CDPRODUTO
                                       FROM
                                          PRODUTO P
                                       WHERE
                                          P.CDPRODUTO = MARCPROD.CDPRODUTO AND
                                          @V_ITEMAUTF_CDARVPROD LIKE P.CDARVPROD + '%') );

                     IF @V_VRARREDEMPE = 0 BEGIN
                        SELECT
                           @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPE), 0)
                        FROM
                           PRODFORNCOMP
                        WHERE
                           (CDFORNECED  = @V_ITEMAUTF_CDFORNECED) AND
                           (CDPRODCOMPL = @V_ITEMAUTF_CDPRODUTO);
                     END;

                     IF @V_VRARREDEMPE > 0 BEGIN
                        SET @V_QTARRED = FLOOR(@V_QTARRED / @V_VRARREDEMPE) * @V_VRARREDEMPE; /* TEM QUE ARREDONDAR PARA BAIXO PARA NAO TIRAR MAIS DO QUE DEVIA */
                     END;

                     IF @V_QTARRED > 0 BEGIN
                        UPDATE ITEMAUTF
                        SET QTPROGENTAF = QTPROGENTAF - @V_QTARRED
                        WHERE
                           (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL) AND
                           (CDFILLANC   = @P_CDFILLANC)              AND
                           (NRAUTOFORN  = @V_ITEMAUTF_NRAUTOFORN)    AND
                           (CDPRODUTO   = @V_ITEMAUTF_CDPRODUTO)     AND
                           (CDMARCA     = @V_ITEMAUTF_CDMARCA)       AND
                           (DTPROGENTAF = @V_ITEMAUTF_DTPROGENTAF);

                        SET @V_LISTA_AF_AUX = 0;

                        SELECT
                           @V_LISTA_AF_AUX = COUNT(*)
                        FROM
                           LISTA
                        WHERE
                           NRLISTA = @V_LISTA_AFS AND
                           CDLISTA = @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN;

                        IF @V_LISTA_AF_AUX = 0 BEGIN
                           INSERT INTO LISTA
                           (NRLISTA, CDLISTA)
                           VALUES
                           (@V_LISTA_AFS, @V_PRODAEMPENHAR_CDFILIAL + @V_ITEMAUTF_NRAUTOFORN);
                        END;

                        SET @V_QTAEMPENHAR = @V_QTAEMPENHAR - (@V_QTARRED);
                        SET @V_QTARETIRAR  = @V_QTARETIRAR - (@V_QTARRED);
                     END;

                     IF (@V_QTARETIRAR > 0) AND (@V_PRODAEMPENHAR_QTAEMPENHAR >= @V_QTARETIRAR) BEGIN
                        IF @V_QTARETIRAR <= @V_QTAEMPENHAR BEGIN
                           /* LOG DE ALTERAO */
                           INSERT INTO MOVOPSOL
                             (CDFILSOLMOV,
                              CDFILLANMOV,
                              NRSOLIMOV,
                              CDPRODUTO,
                              DTENTROPER,
                              DTOPERSOL,
                              CDOPERADOR,
                              QTANTOPER,
                              QTDEPOPER,
                              DSJUSTOPER)
                           SELECT
                              ITEMSOLI.CDFILSOLI,
                              ITEMSOLI.CDFILLAN,
                              ITEMSOLI.NRSOLICMP,
                              ITEMSOLI.CDPRODUTO,
                              ITEMSOLI.DTPROGENTR,
                              GETDATE(),
                              @P_CDOPERADOR,
                              ITEMSOLI.QTSOLIPROD,
                              ITEMSOLI.QTSOLIPROD + @V_QTARETIRAR,
                              'Empenho de AF'
                           FROM
                              ITEMSOLI
                           WHERE
                              (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                              (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                              (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                              (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                              (ITEMSOLI.DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);

                           UPDATE ITEMSOLI
                           SET QTSOLIPROD = QTSOLIPROD + @V_QTARETIRAR
                           WHERE
                              (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                              (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                              (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                              (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                              (DTPROGENTR = @V_ITEMAUTF_DTENTRITMSOL);
                        END;
                     END;
                  END;
               END;
            END;
            --DEFINE AS DATAS FINAL E INICIAL DO PERIODO APURADO NO CURSOR C_ITEMAUTF
            IF (@V_DATAINI IS NULL) BEGIN
               SET @V_DATAINI = @V_ITEMAUTF_DTENTRITMSOL;
            END;
            SET @V_DATAFIN = @V_ITEMAUTF_DTENTRITMSOL; --PEGA A LTIMA DATA, A MAIOR
            --SET @V_VRFATCONVAF = @V_ITEMAUTF_VRFATOCONV;
            SET @V_CDPRODAF    = @V_ITEMAUTF_CDPRODUTO;
            FETCH NEXT FROM C_ITEMAUTF INTO
               @V_ITEMAUTF_CDFORNECED,
               @V_ITEMAUTF_NRAUTOFORN,
               @V_ITEMAUTF_DTPROGENTAF,
               @V_ITEMAUTF_DTENTRITMSOL,
               @V_ITEMAUTF_CDPRODUTO,
               @V_ITEMAUTF_CDMARCA,
               @V_ITEMAUTF_QTPROGENTAF,
               @V_ITEMAUTF_VRFATOCONV,
               @V_ITEMAUTF_VRARREDCMP,
               @V_ITEMAUTF_CDARVPROD;
         END;
         CLOSE C_ITEMAUTF;
         DEALLOCATE C_ITEMAUTF;
         -- Fazer as alteraes aqui, obs: visto que o produto nao muda, essa parte pode nunca ser executada.
         SET @V_CONTADOR = DATEDIFF(DAY, @V_DATAFIN, @V_DATAINI);
         WHILE @V_CONTADOR >= 0 BEGIN
            SET @V_DATA = DATEADD(DD, @V_CONTADOR, @V_DATAINI);
            
            SELECT @V_VRFATCONVAF = MAX(VRFATOCONV)
            FROM PRODUTO
            WHERE CDPRODUTO = @V_PRODAEMPENHAR_CDPRODUTO;
            
            SELECT
               @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
            FROM
               ITEMSOLI
            WHERE
               (ITEMSOLI.CDPRODUTO  = @V_PRODAEMPENHAR_CDPRODUTO)        AND
               (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL) AND
               (ITEMSOLI.DTPROGENTR = @V_DATA)  AND
               ((ITEMSOLI.IDITMSOLEXTRA = @V_EXTRA) OR (@V_EXTRA = 'X'));
            IF @@ROWCOUNT = 0 BEGIN
               SET @V_NRSOLCOMP = NULL;
            END;
            
            IF (@V_NRSOLCOMP IS NOT NULL) BEGIN
               SELECT @V_QTDFINAL = CAST((ITEMSOLI.QTSOLIPROD) AS NUMERIC)%@V_VRFATCONVAF
               FROM ITEMSOLI
               WHERE
                  (ITEMSOLI.CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)       AND
                  (ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                  (ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                  (ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                  (ITEMSOLI.DTPROGENTR = @V_DATA);
               -- BUSCA O VALOR MINIMO DE REJEICAO 
               SELECT @V_REJEICAO = ISNULL(VRMINEMPENHOAF, 0)
               FROM PRODFILI
               WHERE CDFILIAL  = @V_PRODAEMPENHAR_CDFILIAL -- FILIAL SOLICITANTE
                 AND CDPRODUTO = @V_CDPRODAF;
               IF @V_QTDFINAL IS NOT NULL BEGIN
                  IF @V_QTDFINAL > 0 BEGIN
                     UPDATE ITEMSOLI
                     SET QTSOLIPROD = QTSOLIPROD - @V_QTDFINAL
                     WHERE
                        (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)    AND
                        (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                        (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                        (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                        (@V_QTDFINAL >= (@V_VRFATCONVAF*@V_REJEICAO)) AND
                        (DTPROGENTR = @V_DATA);
                     IF @@ROWCOUNT = 0 BEGIN
                        DELETE FROM ITEMSOLI
                        WHERE
                           (CDFILSOLI  = @V_PRODAEMPENHAR_CDFILIAL)    AND
                           (CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4))  AND
                           (NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10))  AND
                           (CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10)) AND
                           (DTPROGENTR = @V_DATA);
                     END;
                     DECLARE C_ITEMAF CURSOR FOR /*DADOS DA AF A SER UPDATADA OU DELETADA*/
                     (
                        SELECT ITF.NRAUTOFORN, ITF.DTPROGENTAF, ITF.CDPRODUTO, ITF.CDMARCA
                        FROM ITEMAUTF ITF
                        WHERE ITF.CDFILLANC    = SUBSTRING(@V_NRSOLCOMP, 11, 4)
                          AND ITF.CDFILDEST    = @V_PRODAEMPENHAR_CDFILIAL
                          AND ITF.DTENTRITMSOL = @V_DATA
                          AND ITF.CDPRODUTO    = @V_PRODAEMPENHAR_CDPRODUTO
                     )
                     OPEN C_ITEMAF;
                     FETCH NEXT FROM C_ITEMAF INTO
                        @C_ITEMAF_NRAUTOFORN,
                        @C_ITEMAF_DTPROGENTAF,
                        @C_ITEMAF_CDPRODUTO,
                        @C_ITEMAF_CDMARCA;
                     WHILE (@@FETCH_STATUS = 0) BEGIN
                        UPDATE ITEMAUTF
                        SET QTPROGENTAF = QTPROGENTAF - @V_QTDFINAL
                        WHERE
                           (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL)   AND
                           (CDFILLANC   = SUBSTRING(@V_NRSOLCOMP, 11, 4)) AND
                           (NRAUTOFORN  = @C_ITEMAF_NRAUTOFORN)        AND
                           (CDPRODUTO   = @C_ITEMAF_CDPRODUTO)         AND
                           (CDMARCA     = @C_ITEMAF_CDMARCA)           AND
                           (DTPROGENTAF = @C_ITEMAF_DTPROGENTAF)       AND
                           (@V_QTDFINAL >= (@V_VRFATCONVAF*@V_REJEICAO));
                        IF @@ROWCOUNT = 0 BEGIN
                           DELETE FROM ITEMAUTF
                           WHERE
                              (CDFILDEST   = @V_PRODAEMPENHAR_CDFILIAL)   AND
                              (CDFILLANC   = SUBSTRING(@V_NRSOLCOMP, 11, 4)) AND
                              (NRAUTOFORN  = @C_ITEMAF_NRAUTOFORN)        AND
                              (CDPRODUTO   = @C_ITEMAF_CDPRODUTO)         AND
                              (CDMARCA     = @C_ITEMAF_CDMARCA)           AND
                              (DTPROGENTAF = @C_ITEMAF_DTPROGENTAF);
                        END;
                        FETCH NEXT FROM C_ITEMAF INTO
                           @C_ITEMAF_NRAUTOFORN,
                           @C_ITEMAF_DTPROGENTAF,
                           @C_ITEMAF_CDPRODUTO,
                           @C_ITEMAF_CDMARCA;
                     END;
                     CLOSE C_ITEMAF;
                     DEALLOCATE C_ITEMAF;
                  END;
               END;               
            END;
            SET @V_CONTADOR = @V_CONTADOR - 1;
         END;
         
         
         FETCH NEXT FROM C_PRODAEMPENHAR INTO
            @V_PRODAEMPENHAR_CDFILIAL,
            @V_PRODAEMPENHAR_CDPRODUTO,
            @V_PRODAEMPENHAR_QTAEMPENHAR;
      END;
      CLOSE C_PRODAEMPENHAR;
      DEALLOCATE C_PRODAEMPENHAR;
   END;

/*############################ FECHAMENTO DAS AF'S ALTERADAS #################################*/
   DELETE FROM AUTOFORNE
   WHERE
      (CDFILLANC   = @P_CDFILLANC) AND
      (NRSEQAPURAF = @P_NRSEQAPUR) AND
      (NOT EXISTS (SELECT
                      ITEMAUTF.CDFILDEST
                   FROM
                      ITEMAUTF
                   WHERE
                      (AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST) AND
                      (AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC) AND
                      (AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN)));


   DECLARE C_AUTOFORNE CURSOR FOR
     (SELECT
         CDFILDEST,
         NRAUTOFORN
      FROM
         AUTOFORNE,
         LISTA
      WHERE
         (CDFILLANC = @P_CDFILLANC) AND
         (NRLISTA   = @V_LISTA_AFS) AND
         (CDLISTA   = CDFILDEST + NRAUTOFORN) )
   OPEN C_AUTOFORNE;
   FETCH NEXT FROM C_AUTOFORNE INTO
      @V_AUTOFORNE_CDFILDEST,
      @V_AUTOFORNE_NRAUTOFORN;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXEC FECHAMENTO_AF @V_AUTOFORNE_CDFILDEST, @P_CDFILLANC, @V_AUTOFORNE_NRAUTOFORN;
      FETCH NEXT FROM C_AUTOFORNE INTO
         @V_AUTOFORNE_CDFILDEST,
         @V_AUTOFORNE_NRAUTOFORN;
   END;
   CLOSE C_AUTOFORNE;
   DEALLOCATE C_AUTOFORNE;
   DELETE FROM LISTA WHERE NRLISTA = @V_LISTA_AFS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'EMPENHAR_AF','5.07.004';
GO

