import { ZdPage } from '@zeedhi/vue';

const routes = [
	{
		path: '/auth/login',
		name: 'login',
		component: ZdPage,
		props: () => ({
			path: 'login',
			local: true,
		}),
	},
	{
        path: '/',
        name: 'home',
        component: ZdPage,
        props: () => ({
            path: 'home',
            local: true,
        }),
    },
    {
        path: '/gestao-de-demandas',
        component: ZdPage,
        name: 'demandManagement',
        props: {
            path: 'demandManagement/tabCall',
            local: true,
        },
    },
    {
        path: '/item-de-trabalho',
        component: ZdPage,
        name: 'item-de-trabalho',
        props: {
            path: 'workItem/workItem',
            local: true,
        },
    },
	{
		path: '/acl-labels',
		component: ZdPage,
		name: 'acl-labels',
		props: {
			path: 'aclLabels/aclLabels',
			local: true,
		},
	},
    {
        path: '/modules/:module/:page',
        name: 'microservice',
        component: () => import('../views/Microservice.vue'),
    },
    {
        path: '*',
        component: ZdPage,
        props: {
            path: 'notfound',
            local: true,
        },
    },
];

export default routes;
